<?php
/**
 * CUser.php
 * 
 * This file is our User class for holding permissions, n` stuffs
 * @author SteamFriends Development Team
 * @version 1.0.0
 * @copyright SteamFriends (www.SteamFriends.com)
 * @package SourceBans
 * @link http://www.sourcebans.net
 */

class CUser
{
	var $aid;
	var $user;
	var $password;
	var $authid;
	var $email;
	var $gid;
	var $flags;
	var $srv_flags;
	
	function CUser($aid)
	{
		$this->aid = $aid;
	}
	
	function FillData()
	{
		$res = $GLOBALS['db']->GetRow("SELECT * FROM `" . DB_PREFIX . "_admins` WHERE `aid` = '$this->aid'");
		if(!$res)
			return false;
			
		$this->user = $res['user'];
		$this->password = $res['password'];
		$this->authid = $res['authid'];
		$this->email = $res['email'];
		$this->gid = $res['gid'];
		$this->flags = $this->get_user_flags($this->aid);
		$this->srv_flags = $this->get_user_admin($this->authid);
	}
	
	function ReturnData()
	{
		$data = array();
		$data['aid'] = $this->aid;
		$data['user'] = $this->user;
		$data['password'] = $this->password;
		$data['authid'] = $this->authid;
		$data['email'] = $this->email;
		$data['flags'] = $this->flags;
		$data['srv_flags'] = $this->srv_flags;
		return $data;
	}
	
	function HasAccess($flag, $all_required=false)
	{
		if(is_numeric($flag))
		{
			if($all_required)
				return ($this->flags & $flag) == $flag;
			else 
				return ($this->flags & $flag) != 0;
		}
		else
		{
			if($all_required)
				return ($this->srv_flags == $flags);
			else 
				return ($this->_has_flag($flag));
		}
	}
	
	function is_admin()
	{
		if ($this->HasAccess(ALL_WEB))
			return true;
		else 
			return false;
	}
	
	/**
	 * Returns the current server flags associated with the user
	 *
	 * @param string The admin to check
	 * @return string.
	 */
	function get_user_admin($steam)
	{	
		if(empty($steam))
			return 0;
		$admin = $GLOBALS['db']->GetRow("SELECT * FROM `" . DB_PREFIX . "_srvadmins` WHERE identity = '$steam'");
		if(strlen($admin['groups']) > 1)
		{
			$query = $GLOBALS['db']->GetRow("SELECT `flags` FROM `" . DB_PREFIX . "_srvgroups` WHERE name = (SELECT `groups` FROM " . DB_PREFIX . "_srvadmins WHERE identity = '$steam')");
			return $query['flags'] . $admin['flags'];
		}
		else 
			return $admin['flags'];		
	}
	
	/**
	 * Returns the current flags associated with the user
	 *
	 * @param integer The admin id to check
	 * @return integer.
	 */
	function get_user_flags($aid)
	{
		if(empty($aid))
			return 0;
		
		$admin = $query = $GLOBALS['db']->GetRow("SELECT `gid`, `extraflags` FROM `" . DB_PREFIX . "_admins` WHERE aid = '$aid'");
		if(intval($admin['gid']) == -1)
			return intval($admin['extraflags']);
		else 
		{
			$query = $GLOBALS['db']->GetRow("SELECT `flags` FROM `" . DB_PREFIX . "_groups` WHERE gid = (SELECT gid FROM " . DB_PREFIX . "_admins WHERE aid = '$aid')");
			return (intval($query['flags']) | intval($admin['extraflags']));
		}
		
	}
	
	function _has_flag($flags)
	{
		for($i=0;$i<strlen($this->srv_flags);$i++)
		{
			for($a=0;$a<strlen($flags);$a++)
			{
				if(strstr($this->srv_flags[$i], $flags[$a]))
					return true;
			}
		}
	}
	
	function GetUserDetails($name="", $aid="")
	{
		$res = $GLOBALS['db']->GetRow("SELECT * FROM `" . DB_PREFIX . "_admins` WHERE `aid` = '$aid' OR `user` = '$name'");
		
		$data = array();
		$data['aid'] = $res['aid'];
		$data['user'] = $res['user'];
		$data['password'] = $res['password'];
		$data['authid'] = $res['authid'];
		$data['email'] = $res['email'];
		$data['flags'] = $this->get_user_flags($admin['aid']);
		return $data;
	}
	
	function GetAllUserDetails()
	{
		$res = $GLOBALS['db']->GetAll("SELECT * FROM `" . DB_PREFIX . "_admins`");
		$ret = array();
		foreach($res AS $admin)
		{
			$data = array();
			$data['aid'] = $admin['aid'];
			$data['user'] = $admin['user'];
			$data['password'] = $admin['password'];
			$data['authid'] = $admin['authid'];
			$data['email'] = $admin['email'];
			$data['flags'] = $this->get_user_flags($admin['aid']);
			$ret[$admin['aid']] = $data;
		}
		
		return $ret;
	}
}
?>