<?php
/**
 * admin.php
 * 
 * This file contains all of our admin stuffs
 * @author SteamFriends Development Team
 * @version 1.0.0
 * @copyright SteamFriends (www.steamfriends.com)
 * @package SourceBans
 * @link http://www.sourcebans.net
 */

if(!is_admin($_SESSION['user']['aid']))
{
		$error = array('title' => "Access Denied",	'message' => "Sorry, but you dont have the required level to view this page.");
		include TEMPLATES_PATH . "/msg.error.php";	
		include TEMPLATES_PATH . "/footer.php";
		RewritePageTitle("Access Denied");
		PageDie();
}
include INCLUDES_PATH . "/CTabsMenu.php";

// BUILD THE SUB-MENU's FOR ADMIN PAGES
$submenu = new CTabsMenu();
if( check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_LIST_ADMINS|ADMIN_ADD_ADMINS|ADMIN_EDIT_ADMINS|ADMIN_DELETE_ADMINS ) )
	$submenu->addMenuItem("Admins", "", "?p=admin&amp;c=admins", true);
if(check_flags($_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_LIST_SERVERS|ADMIN_ADD_SERVER|ADMIN_EDIT_SERVERS|ADMIN_DELETE_SERVERS))
	$submenu->addMenuItem("Servers", "", "?p=admin&amp;c=servers", true);
if(check_flags($_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_ADD_BAN|ADMIN_BAN_LIST|ADMIN_EDIT_OWN_BANS|ADMIN_EDIT_GROUP_BANS|ADMIN_EDIT_ALL_BANS|ADMIN_BAN_PROTESTS|ADMIN_BAN_SUBMISSIONS))
	$submenu->addMenuItem("Bans", "", "?p=admin&amp;c=bans", true);
if(check_flags($_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_LIST_GROUPS|ADMIN_ADD_GROUP|ADMIN_EDIT_GROUPS|ADMIN_DELETE_GROUPS))
	$submenu->addMenuItem("Groups", "", "?p=admin&amp;c=groups", true);
if(check_flags($_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_WEB_SETTINGS))
	$submenu->addMenuItem("SourceBans Settings", "", "?p=admin&amp;c=settings", true);
if(check_flags($_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_LIST_MODS|ADMIN_ADD_MODS|ADMIN_EDIT_MODS|ADMIN_DELETE_MODS))
	$submenu->addMenuItem("Mods", "", "?p=admin&amp;c=mods", true);
SubMenu( $submenu->getMenuArray() );


if(!isset($_GET['c']))
{
	include TEMPLATES_PATH . "/page.admin.php";
	RewritePageTitle("Administration");
}
else 
{
	// ###################[ Admin Groups ]##################################################################
	if($_GET['c'] == "groups")
	{
		CheckAdminAccess( ADMIN_OWNER|ADMIN_LIST_GROUPS|ADMIN_ADD_GROUP|ADMIN_EDIT_GROUPS|ADMIN_DELETE_GROUPS );
		if(!isset($_GET['o']))
		{
			// ====================[ ADMIN SIDE MENU START ] ===================
			$groupsTabMenu = new CTabsMenu();
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_LIST_GROUPS ) )
				$groupsTabMenu->addMenuItem("List groups");
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_ADD_GROUP ) )
				$groupsTabMenu->addMenuItem("Add a group");
			$groupsTabMenu->outputMenu();
			// ====================[ ADMIN SIDE MENU END ] ===================	
			$wa = $GLOBALS['db']->GetAll("SELECT * FROM `" . DB_PREFIX . "_groups` WHERE type != '3'");
			// web groups
			for($i=0;$i<count($wa);$i++)
			{
				$query = $GLOBALS['db']->GetRow("SELECT COUNT(gid) AS cnt FROM `" . DB_PREFIX . "_admins` WHERE gid = '" . $wa[$i]['gid'] . "'");
				$wacount[$i] = $query['cnt'];
			}
			// Server admin groups
			$sa = $GLOBALS['db']->GetAll("SELECT * FROM `" . DB_PREFIX . "_srvgroups`") ;
			for($i=0;$i<count($sa);$i++)
			{
				$query = $GLOBALS['db']->GetRow("SELECT COUNT(id) AS cnt FROM `" . DB_PREFIX . "_srvadmins` WHERE groups = '" . $sa[$i]['name'] . "'");
				$sacount[$i] = $query['cnt'];
			}
			// server groups
			$s = $GLOBALS['db']->GetAll("SELECT * FROM `" . DB_PREFIX . "_groups` WHERE type = '3'") ;
			for($i=0;$i<count($s);$i++)
			{
				$query = $GLOBALS['db']->GetRow("SELECT COUNT(server_id) AS cnt FROM `" . DB_PREFIX . "_servers_groups` WHERE `group_id` = ".  $s[$i]['gid'] ) ;
				$scount[$i] = $query['cnt'];
			}
			include TEMPLATES_PATH . "/admin.groups.php";	
			RewritePageTitle("Group Management");
		}
		elseif($_GET['o'] == 'edit')
		{
			$groupsTabMenu = new CTabsMenu();
			$groupsTabMenu->addMenuItem("Back", "", "javascript:history.go(-1);", true);
			$groupsTabMenu->outputMenu();
			
			include TEMPLATES_PATH . "/admin.edit.group.php";
			RewritePageTitle("Edit Groups");
		}
	}elseif($_GET['c'] == "admins")
	 // ###################[ Admins ]##################################################################
	{
		// Make sure they are allowed here oO
		CheckAdminAccess( ADMIN_OWNER|ADMIN_LIST_ADMINS|ADMIN_ADD_ADMINS|ADMIN_EDIT_ADMINS|ADMIN_DELETE_ADMINS );
		if(!isset($_GET['o']))
		{	
			// ====================[ ADMIN SIDE MENU START ] ===================
			$adminTabMenu = new CTabsMenu();
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_LIST_ADMINS ) )
				$adminTabMenu->addMenuItem("List admins");		
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_ADD_ADMINS ) )
				$adminTabMenu->addMenuItem("Add new admin");
			$adminTabMenu->outputMenu();
			// ====================[ ADMIN SIDE MENU END ] ===================
			$a = $GLOBALS['db']->GetAll("SELECT * FROM `" . DB_PREFIX . "_admins` WHERE aid > 0 ORDER BY user") ;
			$query = $GLOBALS['db']->GetRow("SELECT COUNT(aid) AS cnt FROM `" . DB_PREFIX . "_admins`") ;
			$acount = $query['cnt'];
			include TEMPLATES_PATH . "/admin.admins.php";
			RewritePageTitle("Admin Management");
		}
		elseif($_GET['o'] == 'editgroup' || $_GET['o'] == 'editdetails' || $_GET['o'] == 'editpermissions' || $_GET['o'] == 'editservers')
		{
			$adminTabMenu = new CTabsMenu();
			$adminTabMenu->addMenuItem("Back", "", "javascript:history.go(-1);", true);
			$adminTabMenu->outputMenu();
		
			if($_GET['o'] == 'editgroup')
			{
				include TEMPLATES_PATH . "/admin.edit.admingroup.php";
				RewritePageTitle("Edit Admin Groups");
			}
			elseif($_GET['o'] == 'editdetails')
			{
				include TEMPLATES_PATH . "/admin.edit.admindetails.php";
				RewritePageTitle("Edit Admin Details");
			}
			elseif($_GET['o'] == 'editpermissions')
			{
				include TEMPLATES_PATH . "/admin.edit.adminperms.php";
				RewritePageTitle("Edit Admin Permissions");
			}
			elseif($_GET['o'] == 'editservers')
			{
				include TEMPLATES_PATH . "/admin.edit.adminservers.php";
				RewritePageTitle("Edit Server Access");
			}
		}
	}
	elseif($_GET['c'] == "servers")
	 // ###################[ Servers ]##################################################################
	{
		// Make sure they are allowed here oO
		CheckAdminAccess( ADMIN_OWNER|ADMIN_LIST_SERVERS|ADMIN_ADD_SERVER|ADMIN_EDIT_SERVERS|ADMIN_DELETE_SERVERS );
		if(!isset($_GET['o']))
		{
			// ====================[ ADMIN SIDE MENU START ] ===================
			$serverTabMenu = new CTabsMenu();
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_LIST_SERVERS ) )
				$serverTabMenu->addMenuItem("List servers");	
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_ADD_SERVER ) )
				$serverTabMenu->addMenuItem("Add new server");
			$serverTabMenu->outputMenu();
			// ====================[ ADMIN SIDE MENU END ] ===================
			
			$a = $GLOBALS['db']->GetAll("SELECT * FROM `" . DB_PREFIX . "_servers` ORDER BY modid");
			$query = $GLOBALS['db']->GetRow("SELECT COUNT(sid) AS cnt FROM `" . DB_PREFIX . "_servers`") ;
			$acount = $query['cnt'];
			include TEMPLATES_PATH . "/admin.servers.php";
			RewritePageTitle("Server Management");
		}
		elseif($_GET['o'] == 'edit')
		{
			$serverTabMenu = new CTabsMenu();
			$serverTabMenu->addMenuItem("Back", "", "javascript:history.go(-1);", true);
			$serverTabMenu->outputMenu();		
			
			include TEMPLATES_PATH . "/admin.edit.server.php";
			RewritePageTitle("Edit Server");
		}
		elseif($_GET['o'] == 'rcon')
		{
			$serverTabMenu = new CTabsMenu();
			$serverTabMenu->addMenuItem("Back", "", "javascript:history.go(-1);", true);
			$serverTabMenu->outputMenu();
						
			include TEMPLATES_PATH . "/admin.rcon.php";
			RewritePageTitle("Server RCON");
		}
		elseif($_GET['o'] == 'dbsetup')
		{
			$serverTabMenu = new CTabsMenu();
			$serverTabMenu->addMenuItem("Back", "", "javascript:history.go(-1);", true);
			$serverTabMenu->outputMenu();
						
			include TEMPLATES_PATH . "/admin.servers.db.php";
			RewritePageTitle("Database Config");
		}
		elseif($_GET['o'] == 'admincheck')
		{
			
			$serverTabMenu = new CTabsMenu();
			$serverTabMenu->addMenuItem("Back", "", "javascript:history.go(-1);", true);
			$serverTabMenu->outputMenu();
						
			include TEMPLATES_PATH . "/admin.srvadmins.php";
			RewritePageTitle("Server Admins");
		}
	}
	elseif($_GET['c'] == "bans")
	 // ###################[ Bans ]##################################################################
	{
		CheckAdminAccess( ADMIN_OWNER|ADMIN_ADD_BAN|ADMIN_BAN_LIST|ADMIN_EDIT_OWN_BANS|ADMIN_EDIT_GROUP_BANS|ADMIN_EDIT_ALL_BANS|ADMIN_BAN_PROTESTS|ADMIN_BAN_SUBMISSIONS );
		
		if(!isset($_GET['o']))
		{
			// ====================[ ADMIN SIDE MENU START ] ===================
			$banTabMenu = new CTabsMenu();
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_ADD_BAN ) )
				$banTabMenu->addMenuItem("Add a ban");	
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_BAN_PROTESTS ) )
				$banTabMenu->addMenuItem("Ban protests");			
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_BAN_SUBMISSIONS ) )
				$banTabMenu->addMenuItem("Ban submissions");			
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_BAN_LIST ) )
				$banTabMenu->addMenuItem("Ban list");
			$banTabMenu->outputMenu();	
			// ====================[ ADMIN SIDE MENU END ] ===================

			$s = $GLOBALS['db']->GetAll("SELECT * FROM `" . DB_PREFIX . "_submissions` ORDER BY subid DESC") ;
			$p = $GLOBALS['db']->GetAll("SELECT * FROM `" . DB_PREFIX . "_protests` ORDER BY pid DESC") ;
			$query = $GLOBALS['db']->GetRow("SELECT COUNT(subid) AS cnt FROM `" . DB_PREFIX . "_submissions`") ;
			$acount = $query['cnt'];
			include TEMPLATES_PATH . "/admin.bans.php";
			
			if(isset($_GET['mode']) && $_GET['mode'] == "delete")
				echo "<script>ShowBox('Ban Deleted', 'The ban has been deleted from SourceBans', 'green', '', true);</script>";
			elseif(isset($_GET['mode']) && $_GET['mode']=="unban")
				echo "<script>ShowBox('Player Unbanned', 'The Player has been unbanned from SourceBans', 'green', '', true);</script>";
			
			RewritePageTitle("Bans");
		}
		elseif($_GET['o'] == 'edit')
		{
			$banTabMenu = new CTabsMenu();
			$banTabMenu->addMenuItem("Back", "", "javascript:history.go(-1);", true);
			$banTabMenu->outputMenu();			
			
			include TEMPLATES_PATH . "/admin.edit.ban.php";
			RewritePageTitle("Edit Ban Details");
		}
		elseif($_GET['o'] == 'email')
		{
			$banTabMenu = new CTabsMenu();
			$banTabMenu->addMenuItem("Back", "", "javascript:history.go(-1);", true);
			$banTabMenu->outputMenu();					
			
			include TEMPLATES_PATH . "/admin.email.php";
			RewritePageTitle("Email");
		}
	}
	elseif($_GET['c'] == "mods")
	 // ###################[ Mods ]##################################################################
	{
		CheckAdminAccess( ADMIN_OWNER|ADMIN_LIST_MODS|ADMIN_ADD_MODS|ADMIN_EDIT_MODS|ADMIN_DELETE_MODS );
		if(!isset($_GET['o']))
		{
			// ====================[ ADMIN SIDE MENU START ] ===================
			$modTabMenu = new CTabsMenu();
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_LIST_MODS ) )
				$modTabMenu->addMenuItem("List MODs");
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_ADD_MODS ) )
				$modTabMenu->addMenuItem("Add new MOD");
			$modTabMenu->outputMenu();
			// ====================[ ADMIN SIDE MENU END ] ===================	
			
			$m = $GLOBALS['db']->GetAll("SELECT * FROM `" . DB_PREFIX . "_mods` WHERE mid > 0 ORDER BY name ASC") ;
			$query = $GLOBALS['db']->GetRow("SELECT COUNT(mid) AS cnt FROM `" . DB_PREFIX . "_mods`") ;
			$mcount = $query['cnt'];
			include TEMPLATES_PATH . "/admin.mods.php";
			RewritePageTitle("Manage Mods");	
		}
		elseif($_GET['o'] == 'edit')
		{
			$modTabMenu = new CTabsMenu();
			$modTabMenu->addMenuItem("Back", "", "javascript:history.go(-1);", true);
			$modTabMenu->outputMenu();					
			
			include TEMPLATES_PATH . "/admin.edit.mod.php";
			RewritePageTitle("Edit Mod Details");
		}	
	}
	elseif($_GET['c'] == "settings")
	 // ###################[ Settings ]##################################################################
	{
		CheckAdminAccess( ADMIN_OWNER|ADMIN_WEB_SETTINGS );	
		// ====================[ ADMIN SIDE MENU START ] ===================
			$settingsTabMenu = new CTabsMenu();
			if(check_flags( $_SESSION['user']['aid'], ADMIN_OWNER|ADMIN_WEB_SETTINGS ) )
				$settingsTabMenu->addMenuItem("Main Settings");
			$settingsTabMenu->addMenuItem("System Log");
			$settingsTabMenu->outputMenu();
		// ====================[ ADMIN SIDE MENU END ] ===================
	
		include TEMPLATES_PATH . "/admin.settings.php";
		RewritePageTitle("SourceBans Settings");
	}
}
?>
