<?php
/**
 * sb-callback.php
 * 
 * Contains all of the AJAX php callback functions
 * @author SteamFriends Development Team
 * @version 1.0.0.0
 * @copyright SteamFriends (www.steamfriends.com)
 * @package SourceBans
 */
require_once('xajax.inc.php');
include_once('system-functions.php');
include_once('user-functions.php');
$xajax = new xajax();
//$xajax->debugOn();
$xajax->setRequestURI(XAJAX_REQUEST_URI);
if(check_login($_COOKIE['aid'], $_COOKIE['password']))
{
	$xajax->registerFunction("AddMod");
	$xajax->registerFunction("RemoveMod");
	$xajax->registerFunction("AddGroup");
	$xajax->registerFunction("RemoveGroup");
	$xajax->registerFunction("RemoveAdmin");
	$xajax->registerFunction("RemoveSubmission");
	$xajax->registerFunction("RemoveServer");
	$xajax->registerFunction("UpdateGroupPermissions");
	$xajax->registerFunction("UpdateAdminPermissions");
	$xajax->registerFunction("AddAdmin");
	$xajax->registerFunction("SetupEditServer");
	$xajax->registerFunction("AddServerGroupName");
	$xajax->registerFunction("AddServer");
	$xajax->registerFunction("AddBan");
	$xajax->registerFunction("EditGroup");
	$xajax->registerFunction("RemoveProtest");
	$xajax->registerFunction("SendRcon");
	$xajax->registerFunction("EditAdminPerms");
}

$xajax->registerFunction("Plogin");
$xajax->registerFunction("ServerHostPlayers");
$xajax->registerFunction("DownloadDemo");
$xajax->registerFunction("SetupBan");
$xajax->registerFunction("CheckPassword");
$xajax->registerFunction("ChangePassword");
$xajax->registerFunction("LostPassword");
$xajax->registerFunction("PerformBanSearch");
$xajax->registerFunction("SendMail");
$xajax->registerFunction("Test");

function DownloadDemo($file, $name)
{
	$objResponse = new xajaxResponse();
	if (!file_exists(SB_DEMOS . "/" . $file))
	{
		$objResponse->addAlert("Error: The demo is no longer on the server. Maybe it got deleted.");
		return $objResponse;
	}
	if (($f = fopen(SB_DEMOS . "/" . $file, 'rb')) === false) 
	{
		$objResponse->addAlert("Error: Cannot open file");
		return $objResponse;
	}
	
}

function Plogin($username, $password, $remember, $redirect)
{
	$objResponse = new xajaxResponse();
	$q = $GLOBALS['db']->GetRow("SELECT `aid`, `password` FROM `" . DB_PREFIX . "_admins` WHERE `user` = '$username'");
	$aid = $q[0];
	
	if(strlen($q[1]) == 0 && count($q) != 0)
	{
		$objResponse->addScript("$('msg-blue-login').setStyle('display', 'block');");
		$objResponse->addScript("$('msg-red-login').setStyle('display', 'none');");
		$objResponse->addScript("$('msg-blue-login').setStyle('width', '380px');");
		$objResponse->addScript("$('msg-blue-login').setStyle('margin-bottom', '5px');");
		$objResponse->addScript("$('msg-blue-login').setStyle('margin-top', '15px');");
		$objResponse->addScript("$('login').setStyle('height', '340px');");
			return $objResponse;
	}
	
	if(!check_login($aid, $password))
	{	
		$objResponse->addScript("$('msg-red-login').setStyle('display', 'block');");
		$objResponse->addScript("$('msg-blue-login').setStyle('display', 'none');");
		$objResponse->addScript("$('msg-red-login').setStyle('width', '380px');");
		$objResponse->addScript("$('msg-red-login').setStyle('margin-bottom', '5px');");
		$objResponse->addScript("$('msg-red-login').setStyle('margin-top', '15px');");
		$objResponse->addScript("$('login').setStyle('height', '340px');");
			return $objResponse;
	}
	else {
		$objResponse->addScript("$('msg-red').setStyle('display', 'none');");
	}
	
	if($remember)
		login($aid, $password, true);
	else 
		login($aid, $password, false);
				
	if(strstr($redirect, "validation"))
		$objResponse->addRedirect("?",  0);
	else 
		$objResponse->addRedirect("?" . $redirect, 0);
	return $objResponse;
}

function LostPassword($email)
{
	$objResponse = new xajaxResponse();
	$q = $GLOBALS['db']->GetRow("SELECT * FROM `" . DB_PREFIX . "_admins` WHERE `email` = '$email'");
	
	if(!$q[0])
	{	
		$objResponse->addScript("ShowBox('Error', 'The email address you supplied is not registered on the system', 'red', '');");
			return $objResponse;
	}
	else {
		$objResponse->addScript("$('msg-red').setStyle('display', 'none');");
	}
	
	$validation = md5(time());
	$query = $GLOBALS['db']->Execute("UPDATE `" . DB_PREFIX . "_admins` SET `validate` = '" . $validation . "' WHERE `email` = '" . RemoveCode($email) . "'");
	$message = "";
	$message .= "Hello " . $q['user'] . "\n";
	$message .= "You have requested to have your password reset for your SourceBans account.\n
				 To complete this process, please click the following link.\n
				 NOTE: If you didnt request this reset, then simply ignore this email.\n\n
				 
				 http://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] . "index.php?p=lostpassword&email=". RemoveCode($email) . "&validation=" . $validation;
	
	$headers = 'From: lostpwd@' . $_SERVER['HTTP_HOST'] . "\n" .
    'X-Mailer: PHP/' . phpversion();
	$m = mail($email, "SourceBans Password Reset", $message, $headers);

	$objResponse->addScript("ShowBox('Error', 'Please check your email inbox (and spam) for a link which will help you reset your password.', 'blue', '');");
	return $objResponse;
}

function AddGroup($name, $type, $bitmask, $srvflags)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_ADD_GROUP))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to Add a new group, but doesnt have access.");
		return $objResponse;
	}
		
	$name = RemoveCode($name);
	$error = 0;
	$query = $GLOBALS['db']->GetRow("SELECT `gid` FROM `" . DB_PREFIX . "_groups` WHERE `name` = '$name'");
	if(strlen($name) == 0 || $type == "0" || count($query) > 0)
	{
		if(strlen($name) == 0)
		{
			$objResponse->addAssign("name.msg", "innerHTML", "Please enter a name for this group.");
			$error++;
		}
		else 
		{
			$objResponse->addAssign("name.msg", "innerHTML", "");
			if(strstr($name, ','))
			{
				$objResponse->addAssign("name.msg", "innerHTML", "You cannot have a comma ',' in a group name.");
				$error++;
			}
			else 
				$objResponse->addAssign("name.msg", "innerHTML", "");
		}
		if($type == "0")
		{
			$objResponse->addAssign("type.msg", "innerHTML", "Please choose a type for the group.");
			$error++;
		}
		else 
			$objResponse->addAssign("type.msg", "innerHTML", "");
	
		if(count($query > 0) && strlen($name) != 0)
		{
			$objResponse->addAssign("name.msg", "innerHTML", "A group is already named '" . $name . "'");	
			$error++;
		}
		else 
			$objResponse->addAssign("name.msg", "innerHTML", "");		
	}
	
	if($error > 0)
		return $objResponse;
	
	$query = $GLOBALS['db']->GetRow("SELECT MAX(gid) AS next_gid FROM `" . DB_PREFIX . "_groups`");
	if($type == "1")
	{
		// add the web group
		$query1 = $GLOBALS['db']->Execute("INSERT INTO `" . DB_PREFIX . "_groups` (`gid`, `type`, `name`, `flags`) VALUES (". ($query['next_gid']+1) .", '" . $type . "', '" . $name . "', '" . $bitmask . "')");
	}
	elseif($type == "2")
	{
		if(strstr($srvflags, "#"))
		{
			$immunity = "0";
			$immunity = substr($srvflags, strpos($srvflags, "#")+1);
			$srvflags = substr($srvflags, 0, strlen($srvflags) - strlen($immunity)-1);
		}
		$immunity = ($immunity>0) ? $immunity : 0;
		$add_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvgroups(immunity,flags,name,groups_immune)
					VALUES (?,?,?,?)");
		$GLOBALS['db']->Execute($add_group,array($immunity, $srvflags, $name, " "));
	}
	elseif($type == "3")
	{
		// We need to add the server into the table
		$query1 = $GLOBALS['db']->Execute("INSERT INTO `" . DB_PREFIX . "_groups` (`gid`, `type`, `name`, `flags`) VALUES (". ($query['next_gid']+1) .", '3', '" . $name . "', '0')");
	}
	
	$log = new CSystemLog("m", "Group Created", "A new group was created (" . $name . ")");
    $objResponse->addScript("ShowBox('Group Created', 'Your group has been successfully created.', 'green', 'index.php?p=admin&c=groups', true);");
    $objResponse->addScript("TabToReload();");
	return $objResponse;
}

function RemoveGroup($gid, $type)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_DELETE_GROUPS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to remove a group, but doesnt have access.");
		return $objResponse;
	}
	
	if($type == "web" || $type == "server")
		$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_groups` WHERE gid = $gid");
	else 
		$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_srvgroups` WHERE id = $gid");
		
	$objResponse->addScript("SlideUp('gid_$gid');");
	$log = new CSystemLog("m", "Group Deleted", "Group (" . $gid . ") has been deleted");
	return $objResponse;
}

function RemoveSubmission($sid)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_BAN_SUBMISSIONS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to remove a submission, but doesnt have access.");
		return $objResponse;
	}
	
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_submissions` WHERE subid = $sid");
	$query = $GLOBALS['db']->GetRow("SELECT count(subid) AS cnt FROM `" . DB_PREFIX . "_submissions`");
	$objResponse->addScript("$('subcount').setHTML('" . $query['cnt'] . "');");
	
	$objResponse->addScript("SlideUp('sid_$sid');");
	$objResponse->addScript("SlideUp('sid_" . $sid . "a');");
	$log = new CSystemLog("m", "Submission Deleted", "Submission (" . $sid . ") has been deleted");
	return $objResponse;
}

function RemoveProtest($pid)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_BAN_PROTESTS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to remove a protest, but doesnt have access.");
		return $objResponse;
	}
	
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_protests` WHERE pid = $pid");
	$query = $GLOBALS['db']->GetRow("SELECT count(pid) AS cnt FROM `" . DB_PREFIX . "_protests`");
	$objResponse->addScript("$('protcount').setHTML('" . $query['cnt'] . "');");
	$objResponse->addScript("SlideUp('pid_$pid');");
	$objResponse->addScript("SlideUp('pid_" . $pid . "a');");
	$log = new CSystemLog("m", "Protest Deleted", "Protest (" . $pid . ") has been deleted");
	return $objResponse;
}

function RemoveServer($sid)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_DELETE_SERVERS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to remove a server, but doesnt have access.");
		return $objResponse;
	}
	
	$objResponse->addScript("SlideUp('sid_$sid');");
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_servers` WHERE sid = $sid");
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_servers_groups` WHERE server_id = $sid");
	
	$query = $GLOBALS['db']->GetRow("SELECT count(sid) AS cnt FROM `" . DB_PREFIX . "_servers`");
	$objResponse->addScript("$('srvcount').setHTML('" . $query['cnt'] . "');");
	
	$log = new CSystemLog("m", "Server Deleted", "Server (" . $sid . ") has been deleted");
	return $objResponse;
}

function RemoveMod($mid)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_DELETE_MODS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to remove a mod, but doesnt have access.");
		return $objResponse;
	}
	
	$objResponse->addScript("SlideUp('mid_$mid');");
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_mods` WHERE mid = '$mid'");
	$log = new CSystemLog("m", "MOD Deleted", "MOD (" . $sid . ") has been deleted");
	return $objResponse;
}

function RemoveAdmin($aid)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_DELETE_ADMINS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to remove an admin, but doesnt have access.");
		return $objResponse;
	}
	
	$gid = $GLOBALS['db']->GetRow("SELECT gid, authid, extraflags, user FROM `" . DB_PREFIX . "_admins` WHERE aid = " . $aid);
	if((intval($gid[3]) & ADMIN_OWNER) != 0)
	{
		$objResponse->addAlert("Error: You cannot delete the owner.");
		return $objResponse;
	}
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_admins` WHERE aid = " . $aid);
	$aid = $GLOBALS['db']->GetRow("SELECT id FROM `" . DB_PREFIX . "_srvadmins` WHERE identity = '" . $gid[1] . "'");
	$temp = $GLOBALS['db']->Execute("DELETE FROM " . DB_PREFIX . "_srvadmins WHERE identity = '" . $gid[1] . "'");
	$temp = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_admins_servers_groups` WHERE admin_id = '" . $aid[1] . "'");
	$query = $GLOBALS['db']->GetRow("SELECT count(aid) AS cnt FROM `" . DB_PREFIX . "_admins`");
	$objResponse->addScript("SlideUp('aid_$aid');");
	$objResponse->addScript("$('admincount').setHTML('" . $query['cnt'] . "');");
	
	$log = new CSystemLog("m", "Admin Deleted", "Admin (" . $gid['user'] . ") has been deleted");
	return $objResponse;
}

function AddServer($ip, $port, $rcon, $rcon2, $mod, $group, $group_name)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_ADD_SERVER))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to add a server, but doesnt have access.");
		return $objResponse;
	}
	$ip = RemoveCode($ip);
	$group_name = RemoveCode($group_name);
	
	$error = 0;
	// ip
	if((empty($ip)))
	{
		$error++;
		$objResponse->addAssign("address.msg", "innerHTML", "You must type a the server address.");
		$objResponse->addScript("$('address.msg').setStyle('display', 'block');");
	}
	else 
	{
		$objResponse->addAssign("address.msg", "innerHTML", "");
		if(strlen($ip) > 15)
		{
			$error++;
			$objResponse->addAssign("address.msg", "innerHTML", "You must type a valid IP.");
			$objResponse->addScript("$('address.msg').setStyle('display', 'block');");
		}
		else 
			$objResponse->addAssign("address.msg", "innerHTML", "");
	}
	// Port
	if((empty($port)))
	{
		$error++;
		$objResponse->addAssign("port.msg", "innerHTML", "You must type a the server port.");
		$objResponse->addScript("$('port.msg').setStyle('display', 'block');");
	}
	else 
	{
		$objResponse->addAssign("port.msg", "innerHTML", "");
		if(!is_numeric($port))
		{
			$error++;
			$objResponse->addAssign("port.msg", "innerHTML", "You must type a valid port <b>number</b>.");
			$objResponse->addScript("$('port.msg').setStyle('display', 'block');");
		}
		else 
		{
			$objResponse->addScript("$('port.msg').setStyle('display', 'none');");
			$objResponse->addAssign("port.msg", "innerHTML", "");
		}
	}
	// rcon
	if(!empty($rcon) && $rcon != $rcon2)
	{
		$error++;
		$objResponse->addAssign("rcon2.msg", "innerHTML", "You must type the server RCON password.");
		$objResponse->addScript("$('rcon2.msg').setStyle('display', 'block');");
	}
	else 
		$objResponse->addAssign("rcon2.msg", "innerHTML", "");
	
	// Please Select 
	if($mod == -2)
	{
		$error++;
		$objResponse->addAssign("mod.msg", "innerHTML", "You must select the mod your server runs.");
		$objResponse->addScript("$('mod.msg').setStyle('display', 'block');");
	}
	else 
		$objResponse->addAssign("mod.msg", "innerHTML", "");
	
	if($group == -2)
	{
		$error++;
		$objResponse->addAssign("group.msg", "innerHTML", "You must select an option.");
		$objResponse->addScript("$('group.msg').setStyle('display', 'block');");
	}
	else 
		$objResponse->addAssign("group.msg", "innerHTML", "");

	if($error)
		return $objResponse;
		
	// ##############################################################
	// ##                     Start adding to DB                   ##
	// ##############################################################
	//they wanna make a new group
	$gid = -1;
	$sid = nextSid();
	
	// Add the server
	$addserver = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_servers (`sid`, `ip`, `port`, `rcon`, `modid`)
										  VALUES (?,?,?,?,?)");
	$GLOBALS['db']->Execute($addserver,array($sid, $ip, $port, $rcon, $mod));	
	
	// Add server to each group specified
	$groups = explode(",", $group);
	$addtogrp = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_servers_groups (`server_id`, `group_id`) VALUES (?,?)");
	foreach($groups AS $g)
	{
		if($g)
			$GLOBALS['db']->Execute($addtogrp,array($sid, $g));
	}
		

	$objResponse->addScript("ShowBox('Server Added', 'Your server has been successfully created.', 'green', 'index.php?p=admin&c=servers');");
    $objResponse->addScript("TabToReload();");
    $log = new CSystemLog("m", "Server Added", "Server (" . $ip . ") has been added");
	return $objResponse;
}


function UpdateGroupPermissions($gid)
{
	$objResponse = new xajaxResponse();
		
	if($gid == 1)
	{
		$permissions = @file_get_contents(TEMPLATES_PATH . "/groups.web.perm.php");
		$permissions = str_replace("{title}", "Web Admin Permissions", $permissions);
	}
	elseif($gid == 2)
	{
		$permissions = @file_get_contents(TEMPLATES_PATH . "/groups.server.perm.php");
		$permissions = str_replace("{title}", "Server Admin Permissions", $permissions);
	}
	elseif($gid == 3)
		$permissions = "";
		
	$objResponse->addAssign("perms", "innerHTML", $permissions);	
	$objResponse->addAssign("type.msg", "innerHTML", "");
	return $objResponse;
}

function UpdateAdminPermissions($type, $value)
{
	$objResponse = new xajaxResponse();
	
	if($type == 1)
	{
		$id = "web";
		if($value == "c")
		{
			$permissions = @file_get_contents(TEMPLATES_PATH . "/groups.web.perm.php");
			$permissions = str_replace("{title}", "Web Admin Permissions", $permissions);
		}
		elseif($value == "n")
		{
			$permissions = @file_get_contents(TEMPLATES_PATH . "/group.name.php") . @file_get_contents(TEMPLATES_PATH . "/groups.web.perm.php");
			$permissions = str_replace("{name}", "webname", $permissions);
			$permissions = str_replace("{title}", "New Group Permissions", $permissions);
		}
		else 
			$permissions = "";
	}
	if($type == 2)
	{
		$id = "server";
		if($value == "c")
		{
			$permissions = file_get_contents(TEMPLATES_PATH . "/groups.server.perm.php");
			$permissions = str_replace("{title}", "Server Admin Permissions", $permissions);
		}
		elseif($value == "n")
		{
			$permissions = @file_get_contents(TEMPLATES_PATH . "/group.name.php") . @file_get_contents(TEMPLATES_PATH . "/groups.server.perm.php");
			$permissions = str_replace("{name}", "servername", $permissions);
			$permissions = str_replace("{title}", "New Group Permissions", $permissions);
		}
		else 
			$permissions = "";
	}
	
	$objResponse->addAssign($id."perm", "innerHTML", $permissions);	
	$objResponse->addAssign($id.".msg", "innerHTML", "");
	return $objResponse;

}

function AddServerGroupName()
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_EDIT_GROUPS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to edit group name, but doesnt have access.");
		return $objResponse;
	}
	$inject = '<td valign="top"><div class="rowdesc">' . HelpIcon("Server Group Name", "Please type the name of the new group you wish to create.") . 'Group Name </div></td>';
	$inject .= '<td><div align="left">
        <input type="text" style="border: 1px solid #000000; width: 105px; font-size: 14px; background-color: rgb(215, 215, 215);width: 200px;" id="sgroup" name="sgroup" />
      </div>
        <div id="group_name.msg" style="color:#CC0000;width:195px;display:none;"></div></td>
  ';
	$objResponse->addAssign("nsgroup", "innerHTML", $inject);	
	$objResponse->addAssign("group.msg", "innerHTML", "");
	return $objResponse;

}

function AddAdmin($mask, $srv_mask, $a_name, $a_steam, $a_email, $a_password, $a_password2,	$a_sg, $a_wg, $a_spass, $a_webname, $a_servername, $server, $singlesrv)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_ADD_ADMINS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to add an admin, but doesnt have access.");
		return $objResponse;
	}
	$a_name = RemoveCode($a_name);
	$a_steam = RemoveCode($a_steam);
	$a_email = RemoveCode($a_email);
	$a_servername = RemoveCode($a_servername);
	$a_webname = RemoveCode($a_webname);
	
	
	$error=0;
	if($a_sg == "-2" || $a_wg == "-2")
	{
		ShowBox_ajx("Error", "You must choose an option from the group drop-down boxes", "red", "", true, $objResponse);
		$error++;
	}
	
	//No name
	if(empty($a_name))
	{
		$error++;
		$objResponse->addAssign("name.msg", "innerHTML", "You must type a name for the admin.");
		$objResponse->addScript("$('name.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("name.msg", "innerHTML", "");
		$objResponse->addScript("$('name.msg').setStyle('display', 'none');");
		if(is_taken("admins", "user", $a_name))
		{
			$error++;
			$objResponse->addAssign("name.msg", "innerHTML", "An admin with this name already exists");
			$objResponse->addScript("$('name.msg').setStyle('display', 'block');");
		}
		else 
		{
			$objResponse->addAssign("name.msg", "innerHTML", "");
			$objResponse->addScript("$('name.msg').setStyle('display', 'none');");
		}
	}
	// If they didnt type a steamid, and didnt check the use password box
	if((empty($a_steam) || strlen($a_steam) < 10) && $a_spass == 0)
	{
		$error++;
		$objResponse->addAssign("steam.msg", "innerHTML", "You must type a STEAM ID for the admin.");
		$objResponse->addScript("$('steam.msg').setStyle('display', 'block');");
	}
	else
	{
		$objResponse->addAssign("steam.msg", "innerHTML", "");
		$objResponse->addScript("$('steam.msg').setStyle('display', 'none');");
		if(!validate_steam($a_steam))
		{
			$error++;
			$objResponse->addAssign("steam.msg", "innerHTML", "Please enter a valid STEAM id.");
			$objResponse->addScript("$('steam.msg').setStyle('display', 'block');");
		}	
		else
		{
			$objResponse->addAssign("steam.msg", "innerHTML", "");
			$objResponse->addScript("$('steam.msg').setStyle('display', 'none');");
			if(is_taken("admins", "authid", $a_steam))
			{
				$error++;
				$objResponse->addAssign("steam.msg", "innerHTML", "An admin with this STEAM already exists");
				$objResponse->addScript("$('steam.msg').setStyle('display', 'block');");
			}
			else 
			{
				$objResponse->addAssign("steam.msg", "innerHTML", "");
				$objResponse->addScript("$('steam.msg').setStyle('display', 'none');");
			}
		}
	}
	// If they only want server admin, we dont need an email
	if(empty($a_email) && (check_group($mask) == GROUP_WEB_A || check_group($mask) == GROUP_NONE_A))
	{
		$error++;
		$objResponse->addAssign("email.msg", "innerHTML", "You must type an e-mail address.");
		$objResponse->addScript("$('email.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("email.msg", "innerHTML", "");
		$objResponse->addScript("$('email.msg').setStyle('display', 'none');");
		if(is_taken("admins", "email", $a_email))
		{
			$error++;
			$objResponse->addAssign("email.msg", "innerHTML", "This email address is already being used.");
			$objResponse->addScript("$('email.msg').setStyle('display', 'block');");
		}
		else 
		{
			$objResponse->addAssign("email.msg", "innerHTML", "");
			$objResponse->addScript("$('email.msg').setStyle('display', 'none');");
		/*	if(!validate_email($a_email))
			{
				$error++;
				$objResponse->addAssign("email.msg", "innerHTML", "Please enter a valid email address.");
				$objResponse->addScript("$('email.msg').setStyle('display', 'block');");
			}
			else 
			{
				$objResponse->addAssign("email.msg", "innerHTML", "");
				$objResponse->addScript("$('email.msg').setStyle('display', 'none');");
				
			}*/
		}
	}
	// no pass
	if(empty($a_password) && $srv_mask != SM_RESERVED_SLOT)
	{
		$error++;
		$objResponse->addAssign("password.msg", "innerHTML", "You must type a password.");
		$objResponse->addScript("$('password.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("password.msg", "innerHTML", "");
		$objResponse->addScript("$('password.msg').setStyle('display', 'none');");
	}
	
	if(empty($a_password2))
	{
		$error++;
		$objResponse->addAssign("password2.msg", "innerHTML", "You must type a password");
		$objResponse->addScript("$('password2.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("password2.msg", "innerHTML", "");
		$objResponse->addScript("$('password2.msg').setStyle('display', 'none');");
	}
	
	// no match
	if($a_password != $a_password2 && !empty($a_password2))
	{
		$error++;
		$objResponse->addAssign("password2.msg", "innerHTML", "Your passwords dont match");
		$objResponse->addScript("$('password2.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("password2.msg", "innerHTML", "");
		$objResponse->addScript("$('password2.msg').setStyle('display', 'none');");
	}
	if(strlen($a_password) < MIN_PASS_LENGTH)
	{
		$error++;
		$objResponse->addAssign("password.msg", "innerHTML", "Your password must be at-least " . MIN_PASS_LENGTH . " characters long.");
		$objResponse->addScript("$('password.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("password.msg", "innerHTML", "");
		$objResponse->addScript("$('password.msg').setStyle('display', 'none');");
	}
	
	// chose a new group, but didnt type a name
	if($a_sg == 'n' && empty($a_servername))
	{
		$error++;
		$objResponse->addAssign("servername_err", "innerHTML", "You need to type a name for the new group.");
		$objResponse->addScript("$('servername_err').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("servername_err", "innerHTML", "");
		$objResponse->addScript("$('servername_err').setStyle('display', 'none');");
		if(strstr($a_servername, ','))
		{
			$error++;
			$objResponse->addAssign("servername_err", "innerHTML", "Group name cannot contain a ','");
			$objResponse->addScript("$('servername_err').setStyle('display', 'block');");
		}
		else{
			$objResponse->addAssign("servername_err", "innerHTML", "");
			$objResponse->addScript("$('servername_err').setStyle('display', 'none');");
		}
	}
	if($a_wg == 'n' && empty($a_webname))
	{
		$error++;
		$objResponse->addAssign("webname_err", "innerHTML", "You need to type a name for the new group.");
		$objResponse->addScript("$('webname_err').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("webname_err", "innerHTML", "");
		$objResponse->addScript("$('webname_err').setStyle('display', 'none');");
		if(strstr($a_webname, ','))
		{
			$error++;
			$objResponse->addAssign("webname_err", "innerHTML", "Group name cannot contain a ','");
			$objResponse->addScript("$('webname_err').setStyle('display', 'block');");
		}
		else{
			$objResponse->addAssign("webname_err", "innerHTML", "");
			$objResponse->addScript("$('webname_err').setStyle('display', 'none');");
		}
	}
	// Ohnoes! something went wrong, stop and show errs
	if($error)
	{
		ShowBox_ajx("Error", "There are some errors in your input. Please correct them.", "red", "", true, $objResponse);
		return $objResponse;
	}
		
		
// ##############################################################
// ##                     Start adding to DB                   ##
// ##############################################################
	// They chose a web group, but custom server group
	$gid = 0;
	$done = false;
	$newGroup = "";
	$groupID = 0;
	$inGroup = false;
	$wgid = NextAid();
	if(($a_wg > -1 && $a_wg != 'n' && $a_wg != 'c') && ($a_sg == 'n' || $a_sg == 'c'))
	{	
		// Add custom group for that admin
		if($a_sg == 'c')
		{
			// ##############################################################
			// ##                     Add non group Admin		           ##
			// ##############################################################
			$done = true;			
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
					VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", " ", $srv_mask, $a_name, $wgid));	
		}
		// Add a new group
		elseif($a_sg == 'n')
		{
			$groupID = NextGid();
			$newGroup = $a_servername;
			// ##############################################################
			// ##              Add New Group + Server Admin                ##
			// ##############################################################
			$inGroup = true;
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvgroups(immunity,flags,name,groups_immune)
					VALUES (?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("", $srv_mask, $a_servername, "none"));
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
					VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", $a_servername, "", $a_name, $wgid));	
			
		}
		// ##############################################################
		// ##                     Add Web Admin		                   ##
		// ##############################################################
		$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?, ?,?,?,?,?,?)");
		$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), $a_wg, $a_email, 0));
	}
	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
	// They chose a server group, and custom web group
	if(($a_sg > -1 && $a_sg != 'n' && $a_sg != 'c') && ($a_wg == 'n' || $a_wg == 'c'))
	{	
		$sg = $GLOBALS['db']->GetRow("SELECT `flags`, `name` FROM `" . DB_PREFIX . "_groups` WHERE gid='" . $a_sg . "'");
		$mask |= intval($sg[0]);
		$newGroup = $sg[1];
		$wmask = $mask;
	
		// Add custom group for that admin
		if($a_wg == 'c')
		{
			$done = true;			
			// ##############################################################
			// ##               Custom Web Admin		                   ##
			// ##############################################################
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?, ?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), -1, $a_email, $wmask));
		}
		// Add a new group
		elseif($a_wg == 'n')
		{
			// ##############################################################
			// ##               New	 Web Group			                   ##
			// ##############################################################
			$id = NextGid();
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_groups(gid, type,name,flags)
											VALUES (?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($id, 0, $a_webname, $wmask));
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?, ?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), $id, $a_email, 0));
		}
		// ##############################################################
		// ##               New	Server Admin 		                   ##
		// ##############################################################
		$inGroup = true;
		$groupname = $GLOBALS['db']->GetRow("SELECT `name` FROM ".DB_PREFIX."_srvgroups WHERE id = '" . $a_sg . "'");
		$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
											VALUES (?,?,?,?,?,?,?)");
		$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", $groupname['name'], "", $a_name, $wgid));
	}
	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	

	// They chose 2 custom/new group types
	if(($a_wg == 'n' || $a_wg == 'c') && ($a_sg == 'n' || $a_sg == 'c'))
	{
		$wmask = $mask;
		$smask = $mask;
		//we need to toggle off any server flags to extract the web flags
		
		$smask &= ~(ALL_WEB);
		
		if($a_wg == 'n')
		{
			// ##############################################################
			// ##               New	Web Group	 		                   ##
			// ##############################################################
			$id = NextGid();
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_groups(gid,type,name,flags)
											VALUES (?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($id, 0, $a_webname, $wmask));
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), $id, $a_email, 0));
		}
		if($a_sg == 'n')
		{
			// ##############################################################
			// ##               New	Server Group	 	                   ##
			// ##############################################################
			$inGroup = true;
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvgroups(immunity,flags,name,groups_immune)
					VALUES (?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("", $srv_mask, $a_servername, "none"));
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
					VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", $a_servername, " ", $a_name, $wgid));
		}	
		if($a_wg == 'c')
		{
			// ##############################################################
			// ##               Custom web Group	 	                   ##
			// ##############################################################
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), -1, $a_email, $wmask));	
		}
		if($a_sg == 'c')
		{
			// ##############################################################
			// ##               Custom server admin	 	                   ##
			// ##############################################################
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
					VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", " ", $srv_mask, $a_name, $wgid));	
		}
	}
		
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	// They chose 2 ready-made groups
	if(($a_sg > -1 && $a_sg != 'n' && $a_sg != 'c') && ($a_wg > -1 && $a_wg != 'n' && $a_wg != 'c'))
	{	
		$inGroup = true;
		$groupname = $GLOBALS['db']->GetRow("SELECT `name` FROM ".DB_PREFIX."_srvgroups WHERE id = '" . $a_sg . "'");
		$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
											VALUES (?,?,?,?,?,?,?)");
		$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", $groupname['name'], " ", $a_name, $wgid));
		$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?,?,?,?,?,?,?)");
		$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), $a_wg, $a_email, 0));
	}

	
	// Link with servers
	$aid = $GLOBALS['db']->GetRow("SELECT `id` FROM ".DB_PREFIX."_srvadmins WHERE identity = '" . $a_steam . "'");
	if($inGroup == true)
	{
		if($a_sg == 'n')
			$group_id = $a_servername;
		else 
			$group_id = $a_sg;
	}
	else 
		$group_id = $aid[0];	

	// Add the admin <-> server_group link
	$srv_groups = explode(",", $server);
	$addtosrvgrp = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins_servers_groups(admin_id,group_id,srv_group_id,server_id) VALUES (?,?,?,?)");
	foreach($srv_groups AS $g)
	{
		if($g)
			$GLOBALS['db']->Execute($addtosrvgrp,array($aid['0'], $group_id, substr($g, 1), 0));
	}
	$addtosrv = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins_servers_groups(admin_id,group_id,srv_group_id,server_id) VALUES (?,?,?,?)");
	// Add the admin <-group-> server link
	$srv_arr = explode(",", $singlesrv);
	foreach($srv_arr AS $s)
	{
		if($s)
			$GLOBALS['db']->Execute($addtosrv,array($aid['0'], $group_id, 0, substr($s, 1)));
	}
	$log = new CSystemLog("m", "Admin added", "Admin (" . $a_name . ") has been added");
    $objResponse->addScript("ShowBox('User Added', 'The admin has been added successfully', 'green', 'index.php?p=admin&c=admins');");
    $objResponse->addScript("TabToReload();");
	return $objResponse;
}

function ServerHostPlayers($sid)
{
	$objResponse = new xajaxResponse();
	require INCLUDES_PATH.'/CServerInfo.php';
	$sinfo = new CServerInfo();
	
	$res = $GLOBALS['db']->GetRow("SELECT sid, ip, port FROM ".DB_PREFIX."_servers WHERE sid = '$sid'");
	if(!isset($res[1]) && !isset($res[2]))
		return $objResponse;
	$info = array();
	$info = $sinfo->getInfo($res[1],$res[2]);

	
	if(!empty($info['hostname']))
	{
		$objResponse->addAssign("host_$sid", "innerHTML", trunc($info['hostname'], 48, false));
		$objResponse->addAssign("players_$sid", "innerHTML", $info['numplayers'] . "/" . $info['maxplayers']);
	}else{
		$objResponse->addAssign("host_$sid", "innerHTML", "<b>Error connecting</b> (<i>" . $res[1] . ":" . $res[2]. "</i>)");
		$objResponse->addAssign("players_$sid", "innerHTML", "N/A");
		$objResponse->addScript("$('sid_$sid').setStyle('color', '#adadad');");
	}
	return $objResponse;
}

function AddBan($nickname, $steam, $ip, $length, $dfile, $dname, $reason, $fromsub)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_ADD_BAN))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to add a ban, but doesnt have access.");
		return $objResponse;
	}
	
	$error = 0;
	// If they didnt type a steamid
	if((empty($steam)))
	{
		$error++;
		$objResponse->addAssign("steam.msg", "innerHTML", "You must type a STEAM ID");
		$objResponse->addScript("$('steam.msg').setStyle('display', 'block');");
	}
	else
	{
		$objResponse->addAssign("steam.msg", "innerHTML", "");
		$objResponse->addScript("$('steam.msg').setStyle('display', 'none');");
		if(!validate_steam($steam))
		{
			$error++;
			$objResponse->addAssign("steam.msg", "innerHTML", "Please enter a valid STEAM id.");
			$objResponse->addScript("$('steam.msg').setStyle('display', 'block');");
		}	
		else
		{
			$objResponse->addAssign("steam.msg", "innerHTML", "");
			$objResponse->addScript("$('steam.msg').setStyle('display', 'none');");
		}
	}
	
	if($error > 0)
		return $objResponse;
	
	$nickname = RemoveCode($nickname);
	$ip = RemoveCode($ip);
	$dname = RemoveCode($dname);
	$reason = RemoveCode($reason);
	
	if(!$length)
		$len = 0;
	else 
		$len = $length*60;
		
	$chk = $GLOBALS['db']->GetRow("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans WHERE authid = '" . $steam . "'");
	
	if(intval($chk[0]) > 0)
	{
		$objResponse->addScript("ShowBox('Error', 'SteamID: " . $steam . " is already banned.', 'red', '');");
		return $objResponse;
	}
	
	$pre = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_bans(created,ip,authid,name,ends,length,reason,aid,adminIp ) VALUES 
									(UNIX_TIMESTAMP(),?,?,?,(UNIX_TIMESTAMP() + ?),?,?,?,?)");
	$GLOBALS['db']->Execute($pre,array($ip,
									   $steam,
									   $nickname,
									   $length*60,
									   $len, 
									   $reason, 
									   $_COOKIE['aid'], 
									   $_SERVER['REMOTE_ADDR']));
	$subid = $GLOBALS['db']->Insert_ID();
	
	if($dname && $dfile)
	{
		$GLOBALS['db']->Execute("INSERT INTO ".DB_PREFIX."_demos(demid,demtype,filename,origname) 
						     VALUES($subid,'B','$dfile', '". $dname ."')");
	}
	if($fromsub)
		$GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_submissions` WHERE subid = '" . $fromsub . "'");

	
	
	$objResponse->addScript("ShowBox('Ban Added', 'The ban has been successfully added', 'green', 'index.php?p=admin&c=bans');");
    $objResponse->addScript("TabToReload();");
    $log = new CSystemLog("m", "Ban Added", "Ban against (" . $steam . ") has been added, reason: $reason, length: $length");
	return $objResponse;
}

function SetupBan($subid)
{
	$objResponse = new xajaxResponse();
	$ban = $GLOBALS['db']->GetRow("SELECT * FROM ".DB_PREFIX."_submissions WHERE subid = \"". $subid . "\"");
	$demo = $GLOBALS['db']->GetRow("SELECT * FROM ".DB_PREFIX."_demos WHERE demid = \"". $subid . "\" AND demtype = \"S\"");
	// clear any old stuff
	$objResponse->addScript("$('nickname').value = ''");
	$objResponse->addScript("$('fromsub').value = ''");
	$objResponse->addScript("$('steam').value = ''");
	$objResponse->addScript("$('reason').value = ''");
	$objResponse->addAssign("demo.msg", "innerHTML",  "");
	$objResponse->addAssign("reason", "innerHTML",  "");
	// add new stuff
	$objResponse->addScript("$('nickname').value = '" . $ban['name'] . "'");
	$objResponse->addScript("$('steam').value = '" . $ban['SteamId']. "'");
	$objResponse->addScript("$('reason').value = '" . $ban['reason']. "'");
	$objResponse->addScript("$('fromsub').value = '$subid'");
	if($demo)
	{
		$objResponse->addAssign("demo.msg", "innerHTML",  $demo['origname']);
		$objResponse->addScript("demo('" . $demo['filename'] . "', '" . $demo['origname'] . "');");
	}
	$objResponse->addAssign("reason", "innerHTML",  $ban['reason']);
	$objResponse->addScript("SwapPane(0);");
	return $objResponse;
}

function SetupEditServer($sid)
{
	$objResponse = new xajaxResponse();
	$server = $GLOBALS['db']->GetRow("SELECT * FROM ".DB_PREFIX."_servers WHERE sid = \"". $sid . "\"");
	
	// clear any old stuff
	$objResponse->addScript("$('address').value = ''");
	$objResponse->addScript("$('port').value = ''");
	$objResponse->addScript("$('rcon').value = ''");
	$objResponse->addScript("$('rcon2').value = ''");
	$objResponse->addScript("$('mod').value = '0'");
	$objResponse->addScript("$('serverg').value = '0'");
	
	
	// add new stuff
	$objResponse->addScript("$('address').value = '" . $server['ip']. "'");
	$objResponse->addScript("$('port').value =  '" . $server['port']. "'");
	$objResponse->addScript("$('rcon').value =  '" . $server['rcon']. "'");
	$objResponse->addScript("$('rcon2').value =  '" . $server['rcon']. "'");
	$objResponse->addScript("$('mod').value =  " . $server['modid']);
	$objResponse->addScript("$('serverg').value =  " . $server['gid']);

	$objResponse->addScript("$('insert_type').value =  " . $server['sid']);
	$objResponse->addScript("SwapPane(1);");
	return $objResponse;
}

function CheckPassword($aid, $pass)
{
	$objResponse = new xajaxResponse();
	if(!check_login($aid, $pass))
	{
		$objResponse->addScript("$('current.msg').setStyle('display', 'block');");
		$objResponse->addScript("$('current.msg').setHTML('Incorrect password.');");
		$objResponse->addScript("set_error(1);");
		
	}
	else 
	{
		$objResponse->addScript("$('current.msg').setStyle('display', 'none');");
		$objResponse->addScript("set_error(0);");
	}
	return $objResponse;
}
function ChangePassword($aid, $pass)
{
	$objResponse = new xajaxResponse();
	
	$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_admins` SET `password` = '" . encrypt_password($pass) . "' WHERE `aid` = '" . $aid . "'");
	$objResponse->addAlert("Password changed successfully");
	$objResponse->addRedirect("index.php?p=login", 0);
	$log = new CSystemLog("m", "Password Changed", "Password changed for admin (" . $sid . ")");
	return $objResponse;
}

function AddMod($name, $folder, $icon)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_ADD_MODS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to add a mod, but doesnt have access.");
		return $objResponse;
	}
	$name = RemoveCode($name);
	$pre = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_mods(name,icon,modfolder) VALUES (?,?,?)");
	$GLOBALS['db']->Execute($pre,array($name,
									   $icon,
									   $folder));

									   
	$objResponse->addScript("ShowBox('MOD Added', 'The game MOD has been successfully added', 'green', 'index.php?p=admin&c=mods');");
    $objResponse->addScript("TabToReload();");
    $log = new CSystemLog("m", "MOD Added", "MOD ($name) has been added");
	return $objResponse;
} 

function EditAdminPerms($aid, $web_flags, $srv_flags)
{
	if(empty($aid))
		return;
	$objResponse = new xajaxResponse();	
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_EDIT_ADMINS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to edit admin permissios, but doesnt have access.");
		return $objResponse;
	}
	// Update web stuff
	$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_admins` SET `extraflags` = $web_flags WHERE `aid` = '" . $aid . "'");
	
	
	if(strstr($srv_flags, "#"))
	{
		$immunity = "0";
		$immunity = substr($srv_flags, strpos($srv_flags, "#")+1);
		$srv_flags = substr($srv_flags, 0, strlen($srv_flags) - strlen($immunity)-1);
	}
	$immunity = ($immunity>0) ? $immunity : 0;
	// Update server stuff
	$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_srvadmins` SET `flags` = '$srv_flags', `immunity` = '$immunity' WHERE `external_id` = '" . $aid . "'");
	
	
	$objResponse->addScript("ShowBox('User Added', 'The admin has been added successfully', 'green', 'index.php?p=admin&c=admins');");
    $objResponse->addScript("TabToReload();");
	
    
    $objResponse->addScript("ShowBox('Permissions updated', 'The user`s permissions have been updated successfully', 'green', 'index.php?p=admin&c=admins');");
    $objResponse->addScript("TabToReload();");
    $log = new CSystemLog("m", "Permissions Changed", "Permissions have been changed for ($aid)");
	return $objResponse;
}

function EditGroup($gid, $web_flags, $srv_flags, $type, $name)
{
	$objResponse = new xajaxResponse();
	if(!$GLOBALS['user']->HasAccess(ADMIN_OWNER|ADMIN_EDIT_GROUPS))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to edit group details, but doesnt have access.");
		return $objResponse;
	}
	
	
	$name = RemoveCode($name);
	if($type == "web" || $type == "server" )
	// Update web stuff
	$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_groups` SET `flags` = $web_flags, `name` = '$name' WHERE `gid` = '" . $gid . "'");
	
	if($type == "srv")
	{
		$gname = $GLOBALS['db']->GetRow("SELECT name FROM ".DB_PREFIX."_srvgroups WHERE id = \"". $gid . "\"");
		
		if(strstr($srv_flags, "#"))
		{
			$immunity = 0;
			$immunity = substr($srv_flags, strpos($srv_flags, "#")+1);
			$srv_flags = substr($srv_flags, 0, strlen($srv_flags) - strlen($immunity)-1);
		}
		$immunity = ($immunity>0) ? $immunity : 0;
		
		// Update server stuff
		$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_srvgroups` SET `flags` = '$srv_flags', `name` = '$name', `immunity` = '$immunity' WHERE `id` = '" . $gid . "'");
		
		$oldname = $GLOBALS['db']->GetAll("SELECT * FROM ".DB_PREFIX."_srvadmins WHERE groups = \"". $gname['name'] . "\"");
		foreach($oldname as $o)
		{
			$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_srvadmins` SET `groups` = '" . $name . "' WHERE `id` = '" . $o['id'] . "'");
		}
	}
	
	
	
	
	$objResponse->addScript("ShowBox('Group updated', 'The group has been updated successfully', 'green', 'index.php?p=admin&c=groups');TabToReload();");
	$log = new CSystemLog("m", "Group Updated", "Group ($name) has been updated");
	return $objResponse;
}

function PerformBanSearch($type, $value, $pages, $aid)
{
	$BansPerPage = SB_BANS_PER_PAGE;
	$objResponse = new xajaxResponse();	
	
	if ($pages > 0)
		$page = intval($pages);
	
	$BansStart = ($page-1) * $BansPerPage;
	$BansEnd = $BansStart+$BansPerPage;
	$where = "";
	switch($type)
	{
		case "name":
			$where = "ba.name LIKE '%" . $value . "%' AND";
			$bhist_where = "bh.Name LIKE '%" . $value . "%' AND";
			$where_count = "Name LIKE '%" . $value . "%' AND";
			$col = "name LIKE '%" . $value . "%' AND";
		break;
		case "steam":
			$where = "ba.authid LIKE '%" . $value . "%' AND";
			$bhist_where = "bh.AuthId LIKE '%" . $value . "%' AND";
			$where_count = "AuthId LIKE '%" . $value . "%' AND";
			$col = "AuthId LIKE '%" . $value . "%' AND";
		break;
		case "reason":
			$where = "ba.reason LIKE '%" . $value . "%' AND";
			$bhist_where = "bh.Reason LIKE '%" . $value . "%' AND";
			$where_count = "Reason LIKE '%" . $value . "%' AND";
			$col = "reason LIKE '%" . $value . "%' AND";
		break;
		case "date":
			$date = explode(",", $value);
			$time = mktime(0,0,0,$date[1],$date[0],$date[2]);
			$time2 = mktime(23,59,59,$date[1],$date[0],$date[2]);
			$where = "created > '$time' AND created < '$time2' AND";
			$bhist_where = $where;
			$where_count = $where;
			$col = $where;
		break;
		case "admin":
			$where = "ba.aid='" . $value . "' AND";
			$bhist_where = "bh.AdminId='" . $value . "' AND";
			$where_count = "AdminId='" . $value . "' AND";
			$col = "aid='" . $value . "' AND";
		break;
		case "where_banned":
			$where = "ba.sid='" . $value . "' AND";
			$bhist_where = "bh.SId='" . $value . "' AND";
			$where_count = "SId='" . $value . "' AND";
			$col = "sid='" . $value . "' AND";
		break;
		default:
			$where = "";
			$bhist_where = $where;
			$where_count = $where;
			$col = "";
		break;		
	}
	
	$sql = "SELECT bid, ba.ip, ba.authid, ba.name, created, ends, length, reason, ba.aid, ba.sid, ad.user, CONCAT( se.ip, ':', se.port ) AS serverAddr , se.sid, mo.icon, ba.country, (
				SELECT count( * ) 
				FROM ".DB_PREFIX."_banhistory bh
				WHERE bh.AuthId = ba.authid
			) AS `histCount`
			FROM ".DB_PREFIX."_bans AS ba
			LEFT JOIN ".DB_PREFIX."_admins AS ad ON ba.aid = ad.aid
			LEFT JOIN ".DB_PREFIX."_servers AS se ON se.sid = ba.sid
			LEFT JOIN ".DB_PREFIX."_mods AS mo ON mo.mid = se.modid
			WHERE $where (`length` = '0' OR `ends` > UNIX_TIMESTAMP())
			UNION
			SELECT CONCAT( HistId, '-', AdminId ) , bh.IP, AuthId, bh.Name, Created, Ends, Length, Reason, AdminId, bh.SId, (
				SELECT user
				FROM ".DB_PREFIX."_admins
				WHERE aid = AdminId
			), 
			RemovedBy, RemovedOn,TYPE , mo.icon, country
			FROM ".DB_PREFIX."_banhistory bh
			LEFT JOIN ".DB_PREFIX."_servers AS se ON se.sid = bh.SId
			LEFT JOIN ".DB_PREFIX."_mods AS mo ON mo.mid = se.modid
			WHERE $bhist_where Created > 0
			ORDER BY created DESC 
			LIMIT $BansStart, $BansPerPage";
	$sql_count = "SELECT (count(bid) + 
							(SELECT count(HistId) FROM ".DB_PREFIX."_banhistory 
							WHERE $where_count created > 0)) 
				  FROM ".DB_PREFIX."_bans 
				  WHERE $col (`length` = '0' OR `ends` > UNIX_TIMESTAMP())";
	$res = $GLOBALS['db']->Execute($sql);
	$res_cnt = $GLOBALS['db']->Execute($sql_count);
	if(!$res->fields)
	{
		$objResponse->addAssign("banlist_result", "innerHTML",  "<h2>No bans found.</h2>");
		return $objResponse;
	}
	$BanCount = $res_cnt->fields[0];
	$prev = "javascript:xajax_PerformBanSearch('$type', '$value', " . ($page-1) . ", $aid);";
	$nxt = "javascript:xajax_PerformBanSearch('$type', '$value', " . ($page+1) . ", $aid);";
	if ($page > 1)
		$prev = CreateLinkR('<img border="0" alt="prev" src="images/left.gif" style="vertical-align:middle;" /> prev',"javascript:void(0);", "", "_self", false, $prev);
	else
		$prev = "";
		
	if ($BansEnd < $BanCount)
		$next = CreateLinkR('next <img border="0" alt="next" src="images/right.gif" style="vertical-align:middle;" />',"javascript:void(0);", "", "_self", false, $nxt);
	else
		$next = "";
	
	$bans = array();
	$pre = $GLOBALS['db']->Prepare("SELECT count(*) FROM ".DB_PREFIX."_banhistory WHERE AuthId=?");
	$ServerCache = CreateHostnameCache();
	while (!$res->EOF)
	{
		$data = array();
		if(strstr($res->fields[0], "-"))
		{
			$data['unbanned'] = true;
			$data['class'] = "listtable_1_unbanned";
		}
		else 
		{
			$data['unbanned'] = false;
			$data['class'] = "listtable_1";
		}

		$admin = $GLOBALS['db']->GetRow("SELECT user FROM ".DB_PREFIX."_admins WHERE aid = " . $res->fields[8]);
		
		if(!empty($res->fields['ip']) )
		{
			if(!empty($res->fields['country']) && !$data['unbanned'])
				$data['country'] = '<img src="/images/country/' .strtolower($res->fields['country']) . '.gif" alt="' . $res->fields['country'] . '" border="0" align="absmiddle" />';
			elseif(!empty($res->fields['histCount']) && $data['unbanned'])
				$data['country'] = '<img src="/images/country/' .strtolower($res->fields['histCount']) . '.gif" alt="' . $res->fields['histCount'] . '" border="0" align="absmiddle" />';
			else 
			{
				$country = FetchIp($res->fields['ip']);
				if(!$data['unbanned'])
				{
					$edit = $GLOBALS['db']->Execute("UPDATE ".DB_PREFIX."_bans SET
									`country` = '" . $country . "'
									WHERE `bid` = '". $res->fields['bid'] . "'");
				}
				else 
				{
					$bid = explode("-", $res->fields['bid']);
					$edit = $GLOBALS['db']->Execute("UPDATE ".DB_PREFIX."_banhistory SET
									`country` = '" . $country . "'
									WHERE `HistId` = '". $bid[0] . "'");
				}
				$data['country'] = '<img src="/images/country/' . $country . '.gif" alt="' . $country . '" border="0" align="absmiddle" />';
			}
		}
		
		$data['ban_date'] = date('d-m-y',$res->fields[4]);
		$data['player'] = $res->fields[3];
		$data['steamid'] = $res->fields[2];
		$data['admin'] = $admin[0];
		$data['reason'] = $res->fields[7];
		$data['ban_length'] = $res->fields[6] == 0 ? 'Permanent' : SecondsToString(intval($res->fields[6]));
		$data['layer_id'] = 'layer_'.$res->fields[0];
		$data['details_link'] = CreateLinkR('click','getdemo.php?type=B&id='.$res->fields[0]);
		$data['edit_link'] = CreateLinkR('<img src="images/edit.gif" border="0" alt="" style="vertical-align:middle" /> Edit Details',"index.php?p=admin&c=bans&o=edit&id=".$res->fields[0]."&ajx=true");
		$data['unban_link'] = CreateLinkR('<img src="images/locked.gif" border="0" alt="" style="vertical-align:middle" /> Unban',"index.php?p=banlist&a=unban&id=".$res->fields[0]."&ajx=true");
		$data['delete_link'] = CreateLinkR('<img src="images/delete.gif" border="0" alt="" style="vertical-align:middle" /> Delete Ban',"index.php?p=banlist&a=delete&id=".$res->fields[0]."&ajx=true");
		$data['prevoff_link'] = "0";
		$data['server_id'] = $res->fields['sid'];
		
	
		if($data['unbanned'])
		{
			if(isset($res->fields['country']))
				$data['mod_icon'] = '<img src="images/games/' .$res->fields['country'] . '" alt="MOD" border="0" align="absmiddle" />&nbsp;' . strtolower($data['country']) ;
			elseif(isset($data['country'])) 
				$data['mod_icon'] = '<img src="images/games/web.png" alt="MOD" border="0" align="absmiddle" />&nbsp;' . strtolower($data['country']) ;	
		}
		else 
			$data['mod_icon'] = '<img src="images/games/web.png" alt="MOD" border="0" align="absmiddle" />&nbsp;' . strtolower($data['country']) ;
		
		if($data['unbanned'])
		{
			if($res->fields[13] == "E")
				$data['ub_reason'] = "(Expired)";
			if($res->fields[13] == "D")
				$data['ub_reason'] = "(Deleted)";
			if($res->fields[13] == "U")
				$data['ub_reason'] = "(Unbanned)";
		}
		else 
			$data['ub_reason'] = "";	
		
		$res2 = $GLOBALS['db']->Execute($pre,array($data['steamid']));
		if ($res2 && $res2->fields[0] > 0)
			$data['prevoff_link'] = CreateLinkR($res2->fields[2],"index.php?p=prevoff&id=".$res->fields[0]);
		
		if ($res2 && $res->fields[12] != 0)
			$data['prevoff_link'] = $res->fields[11];
		else
			$data['prevoff_link'] = 'unknown';
		
		if (strlen($res->fields[ip]) < 7)
			$data['ip'] = 'none';
		else
			$data['ip'] = $data['country'] . '&nbsp;' . $res->fields[ip];
		
		if ($res->fields[5] == 0)
			$data['expires'] = 'never';
		else
			$data['expires'] = date('m-d-y',$res->fields[5]);
			
		$res2 = $GLOBALS['db']->Execute("SELECT demid FROM ".DB_PREFIX."_demos WHERE demtype='B' and demid=".$res->fields[0]);
		if (!$res2 || $res2->RecordCount() == 0)
		{
			$data['demo_quick'] = 'N/A';
			$data['demo_link'] = CreateLinkR('<img src="images/demo.gif" border="0" alt="" style="vertical-align:middle" /> No Demos',"#");
		}
		elseif ($res2 && $res2->RecordCount() == 1)
		{
			$data['demo_quick'] = CreateLinkR('Demo',"getdemo.php?type=B&id=".$res->fields[0]);
			$data['demo_link'] = CreateLinkR('<img src="images/demo.gif" border="0" alt="" style="vertical-align:middle" /> Review Demo',"getdemo.php?type=B&id=".$res->fields[0]);
		}
		else
		{
			//Multiple demos..
			$data['demo_quick'] = 'Demos';
			$data['demo_link'] = '<img src="images/demo.gif" border="0" alt="" style="vertical-align:middle" /> Review Demos';
		}
		$data['server'] = $ServerCache[$res->fields[10]];
		array_push($bans,$data);
		$res->MoveNext();
		
	}
	$header = '<h3 align="left">Banlist Overview</h3>';
	$pages = round($BanCount/$BansPerPage);
	if($pages == 0)
		$pages = 1;
	$header .= '<div id="banlist-nav">Page ' . $page . ' of ' . $pages;
	if (strlen($prev) > 0)
		$header .= '| <b>'.$prev.'</b>';
	if (strlen($next) > 0)
		$header .= '| <b>'.$next.'</b>';
		
	$header .= "</div>" . include(TEMPLATES_PATH . "/banlist.header.php");
	$GLOBALS['aid'] = $aid;
	$GLOBALS['admin'] = true;
	foreach ($bans as $cur)
	{
		$banlen = explode(',',$cur['ban_length']);
		$cur['banlength'] = $banlen[0] . " " . $cur['ub_reason'];
		$ban .=  include(TEMPLATES_PATH . "/banlist.bandetail.php");		
	}
	$foot = include(TEMPLATES_PATH . "/banlist.footer.php");
	
	$objResponse->addAssign("banlist_result", "innerHTML",  $header . $ban . $foot);
	$objResponse->addScript("InitAccordion('tr.opener', 'div.opener', 'mainwrapper');");
	
	return $objResponse;
}


function SendRcon($sid, $command, $output)
{	
	$objResponse = new xajaxResponse();	
	if(!$GLOBALS['user']->HasAccess(SM_RCON . SM_ROOT))
	{
		$objResponse->redirect("index.php?p=login&m=no_access", 0);
		$log = new CSystemLog("w", "Hacking Attempt", $username . " tried to send an rcon command, but doesnt have access.");
		return $objResponse;
	}
	if($command == "clr")
	{
		$objResponse->addAssign("rcon_con", "innerHTML",  "");
		$objResponse->addScript("scroll.toBottom(); $('cmd').value=''; $('cmd').disabled='';$('rcon_btn').disabled=''");
		return $objResponse;
	}
	$rcon = $GLOBALS['db']->GetRow("SELECT ip, port, rcon FROM ".DB_PREFIX."_servers WHERE sid = \"". $sid . "\"");
	include(INCLUDES_PATH . "/CServerRcon.php");
	$r = new CServerRcon($rcon['ip'], $rcon['port'], $rcon['rcon']);
	if(!$r->Auth())
	{
		$objResponse->addAssign("rcon_con", "innerHTML",  "> Error: Wrong RCON password!\nYou MUST change the RCON password for this server in the 'edit server' \npage. If you continue to use this console with the wrong password, \nthe server will block the connection!");
		$objResponse->addScript("scroll.toBottom(); $('cmd').value='Change RCON password.'; ");
		return $objResponse;
	}
	$ret = $r->rconCommand($command);
	
	
	$ret = str_replace('\n', '\n\r', $ret);
	if(empty($ret))
	{
		if($output)
		{
			$objResponse->addAppend("rcon_con", "innerHTML",  "-> $command\r\n");
			$objResponse->addAppend("rcon_con", "innerHTML",  "Command Executed.\n");
		}
	}
	else 
	{
		if($output)
		{
			$objResponse->addAppend("rcon_con", "innerHTML",  "-> $command\n");
			$objResponse->addAppend("rcon_con", "innerHTML",  "$ret\r\n");
		}
	}
	$objResponse->addScript("scroll.toBottom(); $('cmd').value=''; $('cmd').disabled=''; $('rcon_btn').disabled=''");
	$log = new CSystemLog("m", "RCON Sent", "RCON Command was sent to server ($sid): $command");
	return $objResponse;
}


function SendMail($subject, $message, $amail, $email)
{
	$objResponse = new xajaxResponse();
	$headers = 'From: ' . $amail . '\n' .
    'X-Mailer: PHP/' . phpversion();
	$m = mail($email, $subject, $message, $headers);
	
	$objResponse->addScript("ShowBox('Email Sent', 'The email has been sent to the user.', 'green', 'index.php?p=admin&c=bans');");
	return $objResponse;
}

function Test()
{
	$objResponse = new xajaxResponse();
	$objResponse->addAlert("test worked");
	return $objResponse;
}
?>