<?php
/**
 * sb-callback.php
 * 
 * Contains all of the AJAX php callback functions
 * @author SteamFriends Development Team
 * @version 1.0.0.0
 * @copyright SteamFriends (www.steamfriends.com)
 * @package SourceBans
 */
require_once('xajax.inc.php');
include_once('system-functions.php');
include_once('user-functions.php');
$xajax = new xajax();
//$xajax->debugOn();
$xajax->setRequestURI(XAJAX_REQUEST_URI);

$xajax->registerFunction("ShowPage");
$xajax->registerFunction("Plogin");
$xajax->registerFunction("AddGroup");
$xajax->registerFunction("Redirect");
$xajax->registerFunction("RemoveGroup");
$xajax->registerFunction("RemoveAdmin");
$xajax->registerFunction("RemoveSubmission");
$xajax->registerFunction("RemoveServer");
$xajax->registerFunction("UpdateGroupPermissions");
$xajax->registerFunction("UpdateAdminPermissions");
$xajax->registerFunction("AddAdmin");
$xajax->registerFunction("ServerHostPlayers");
$xajax->registerFunction("AddServerGroupName");
$xajax->registerFunction("AddServer");
$xajax->registerFunction("AddBan");
$xajax->registerFunction("DownloadDemo");
$xajax->registerFunction("SetupBan");
$xajax->registerFunction("SetupEditServer");
$xajax->registerFunction("CheckPassword");
$xajax->registerFunction("ChangePassword");
$xajax->registerFunction("AddMod");
$xajax->registerFunction("RemoveMod");
$xajax->registerFunction("LostPassword");
$xajax->registerFunction("EditAdminPerms");
$xajax->registerFunction("EditGroup");
$xajax->registerFunction("RemoveProtest");
$xajax->registerFunction("PerformBanSearch");
$xajax->registerFunction("SendRcon");
$xajax->registerFunction("SendMail");

function ShowPage(){
	$objResponse = new xajaxResponse();
	ob_start();
	
	$objResponse->addAssign("content_text", "innerHTML", "I AM THE NEW PAGE<br>I AM THE NEW PAGE<br>I AM THE NEW PAGE<br>I AM THE NEW PAGE<br>I AM THE NEW PAGE<br>");
	return $objResponse;
}

function Redirect()
{
	$objResponse = new xajaxResponse();
}

function DownloadDemo($file, $name)
{
	$objResponse = new xajaxResponse();
	if (!file_exists(SB_DEMOS . "/" . $file))
	{
		$objResponse->addAlert("Error: The demo is no longer on the server. Maybe it got deleted.");
		return $objResponse;
	}
	if (($f = fopen(SB_DEMOS . "/" . $file, 'rb')) === false) 
	{
		$objResponse->addAlert("Error: Cannot open file");
		return $objResponse;
	}
	
}

function Plogin($username, $password, $remember, $redirect)
{
	$objResponse = new xajaxResponse();
	$q = $GLOBALS['db']->GetRow("SELECT `aid`, `password` FROM `" . DB_PREFIX . "_admins` WHERE `user` = '$username'");
	$aid = $q[0];
	
	if(strlen($q[1]) == 0 && count($q) != 0)
	{
		$objResponse->addScript("$('msg-blue').setStyle('display', 'block');");
		$objResponse->addScript("$('msg-red').setStyle('display', 'none');");
		$objResponse->addScript("$('msg-blue').setStyle('width', '380px');");
		$objResponse->addScript("$('msg-blue').setStyle('margin-bottom', '5px');");
		$objResponse->addScript("$('msg-blue').setStyle('margin-top', '15px');");
		$objResponse->addScript("$('login').setStyle('height', '340px');");
			return $objResponse;
	}
	
	if(!check_login($aid, $password))
	{	
		$objResponse->addScript("$('msg-red').setStyle('display', 'block');");
		$objResponse->addScript("$('msg-blue').setStyle('display', 'none');");
		$objResponse->addScript("$('msg-red').setStyle('width', '380px');");
		$objResponse->addScript("$('msg-red').setStyle('margin-bottom', '5px');");
		$objResponse->addScript("$('msg-red').setStyle('margin-top', '15px');");
		$objResponse->addScript("$('login').setStyle('height', '340px');");
			return $objResponse;
	}
	else {
		$objResponse->addScript("$('msg-red').setStyle('display', 'none');");
	}
	
	if($remember)
		login($aid, $password, true);
	else 
		login($aid, $password, false);
	
	if(strstr($redirect, "validation"))
		$objResponse->addRedirect("?",  0);
	else 
		$objResponse->addRedirect("?" . $redirect, 0);
	return $objResponse;
}

function LostPassword($email)
{
	$objResponse = new xajaxResponse();
	$q = $GLOBALS['db']->GetRow("SELECT * FROM `" . DB_PREFIX . "_admins` WHERE `email` = '$email'");
	
	if(!$q[0])
	{	
		$objResponse->addScript("ShowBox('Error', 'The email address you supplied is not registered on the system', 'red', '');");
			return $objResponse;
	}
	else {
		$objResponse->addScript("$('msg-red').setStyle('display', 'none');");
	}
	
	$validation = md5(time());
	$query = $GLOBALS['db']->Execute("UPDATE `" . DB_PREFIX . "_admins` SET `validate` = '" . RemoveCode($validation) . "' WHERE `email` = '$email'");
	$message = "";
	$message .= "Hello " . $q['user'] . "\n";
	$message .= "You have requested to have your password reset for your SourceBans account.\n
				 To complete this process, please click the following link.\n
				 NOTE: If you didnt request this reset, then simply ignore this email.\n\n
				 
				 http://" . SB_LOCATION . "/?p=lostpassword&email=". RemoveCode($email) . "&validation=" . RemoveCode($validation);
	
	$headers = 'From: lostpwd@' . $_SERVER['HTTP_HOST'] . "\n" .
    'X-Mailer: PHP/' . phpversion();
	$m = mail($email, "SourceBans Password Reset", $message, $headers);

	$objResponse->addScript("ShowBox('Error', 'Please check your email inbox (and spam) for a link which will help you reset your password.', 'blue', '');");
	return $objResponse;
}

function AddGroup($name, $type, $bitmask, $srvflags)
{
	$name = RemoveCode($name);
	$objResponse = new xajaxResponse();
	$error = 0;
	$query = $GLOBALS['db']->GetRow("SELECT `gid` FROM `" . DB_PREFIX . "_groups` WHERE `name` = '$name'");
	if(strlen($name) == 0 || $type == "0" || count($query) > 0)
	{
		if(strlen($name) == 0)
		{
			$objResponse->addAssign("name.msg", "innerHTML", "Please enter a name for this group.");
			$error++;
		}
		else 
		{
			$objResponse->addAssign("name.msg", "innerHTML", "");
			if(strstr($name, ','))
			{
				$objResponse->addAssign("name.msg", "innerHTML", "You cannot have a comma ',' in a group name.");
				$error++;
			}
			else 
			{
				$objResponse->addAssign("name.msg", "innerHTML", "");
			}
		}
		if($type == "0")
		{
			$objResponse->addAssign("type.msg", "innerHTML", "Please choose a type for the group.");
			$error++;
		}
		else 
		{
			$objResponse->addAssign("type.msg", "innerHTML", "");
		}
	
		if(count($query > 0) && strlen($name) != 0)
		{
			$objResponse->addAssign("name.msg", "innerHTML", "A group is already named '" . $name . "'");	
			$error++;
		}
		else 
			$objResponse->addAssign("name.msg", "innerHTML", "");		
	}
	
	if($error > 0)
		return $objResponse;
	
	$query = $GLOBALS['db']->GetRow("SELECT MAX(gid) AS next_gid FROM `" . DB_PREFIX . "_groups`");
	
	if($type == 1)
	{
		// add the web group
		$query1 = $GLOBALS['db']->Execute("INSERT INTO `" . DB_PREFIX . "_groups` (`gid`, `type`, `name`, `flags`) VALUES (". ($query['next_gid']+1) .", '" . $type . "', '" . $name . "', '" . $bitmask . "')");
	}
	elseif($type == 2)
	{
		// We must add the server group to the SM table
		$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvgroups(immunity,flags,name,groups_immune)
					VALUES (?,?,?,?)");
		$GLOBALS['db']->Execute($sm_group,array("", $srvflags, $name, "none"));
	}
	elseif($type == 3)
	{
		// We need to add the server into the table
		$query1 = $GLOBALS['db']->Execute("INSERT INTO `" . DB_PREFIX . "_groups` (`gid`, `type`, `name`, `flags`) VALUES (". ($query['next_gid']+1) .", '3', '" . $name . "', '0')");
	}
	
	
    $objResponse->addScript("ShowBox('Group Created', 'Your group has been successfully created.', 'green');");
    $objResponse->addScript("TabToReload();");
	return $objResponse;
}

function RemoveGroup($gid, $type)
{
	$objResponse = new xajaxResponse();
	if($type == "web" || $type == "server")
		$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_groups` WHERE gid = $gid");
	else 
		$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_srvgroups` WHERE id = $gid");
		
	$objResponse->addScript("SlideUp('gid_$gid');");
	return $objResponse;
}

function RemoveSubmission($sid)
{
	$objResponse = new xajaxResponse();
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_submissions` WHERE subid = $sid");
	$query = $GLOBALS['db']->GetRow("SELECT count(subid) AS cnt FROM `" . DB_PREFIX . "_submissions`");
	$objResponse->addScript("$('subcount').setHTML('" . $query['cnt'] . "');");
	
	$objResponse->addScript("SlideUp('sid_$sid');");

	return $objResponse;
}

function RemoveProtest($pid)
{
	$objResponse = new xajaxResponse();
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_protests` WHERE pid = $pid");
	$query = $GLOBALS['db']->GetRow("SELECT count(pid) AS cnt FROM `" . DB_PREFIX . "_protests`");
	$objResponse->addScript("$('protcount').setHTML('" . $query['cnt'] . "');");
	$objResponse->addScript("SlideUp('pid_$pid');");
	return $objResponse;
}

function RemoveServer($sid)
{
	$objResponse = new xajaxResponse();
	$objResponse->addScript("SlideUp('sid_$sid');");
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_servers` WHERE sid = $sid");
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_servers_groups` WHERE server_id = $sid");
	
	$query = $GLOBALS['db']->GetRow("SELECT count(sid) AS cnt FROM `" . DB_PREFIX . "_servers`");
	$objResponse->addScript("$('srvcount').setHTML('" . $query['cnt'] . "');");
	return $objResponse;
}

function RemoveMod($mid)
{
	$objResponse = new xajaxResponse();
	$objResponse->addScript("SlideUp('mid_$mid');");
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_mods` WHERE mid = '$mid'");
	return $objResponse;
}

function RemoveAdmin($aid)
{
	$objResponse = new xajaxResponse();
	
	$gid = $GLOBALS['db']->GetRow("SELECT gid, authid, extraflags FROM `" . DB_PREFIX . "_admins` WHERE aid = " . $aid);
	if((intval($gid[3]) & ADMIN_OWNER) != 0)
	{
		$objResponse->addAlert("Error: You cannot delete the owner.");
		return $objResponse;
	}
	$query1 = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_admins` WHERE aid = " . $aid);
	$aid = $GLOBALS['db']->GetRow("SELECT id FROM `" . DB_PREFIX . "_srvadmins` WHERE identity = '" . $gid[1] . "'");
	$temp = $GLOBALS['db']->Execute("DELETE FROM " . DB_PREFIX . "_srvadmins WHERE identity = '" . $gid[1] . "'");
	$temp = $GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_admins_servers_groups` WHERE admin_id = '" . $aid[1] . "'");
	$query = $GLOBALS['db']->GetRow("SELECT count(aid) AS cnt FROM `" . DB_PREFIX . "_admins`");
	$objResponse->addScript("SlideUp('aid_$aid');");
	$objResponse->addScript("$('admincount').setHTML('" . $query['cnt'] . "');");
	return $objResponse;
}

function AddServer($ip, $port, $rcon, $rcon2, $mod, $group, $group_name)
{
	$objResponse = new xajaxResponse();
	$ip = RemoveCode($ip);
	$group_name = RemoveCode($group_name);
	
	$error = 0;
	// ip
	if((empty($ip)))
	{
		$error++;
		$objResponse->addAssign("address.msg", "innerHTML", "You must type a the server address.");
		$objResponse->addScript("$('address.msg').setStyle('display', 'block');");
	}
	else 
	{
		$objResponse->addAssign("address.msg", "innerHTML", "");
		if(strlen($ip) > 15)
		{
			$error++;
			$objResponse->addAssign("address.msg", "innerHTML", "You must type a valid IP.");
			$objResponse->addScript("$('address.msg').setStyle('display', 'block');");
		}
		else 
		{
			$objResponse->addAssign("address.msg", "innerHTML", "");
		}
	}
	// Port
	if((empty($port)))
	{
		$error++;
		$objResponse->addAssign("port.msg", "innerHTML", "You must type a the server port.");
		$objResponse->addScript("$('port.msg').setStyle('display', 'block');");
	}
	else 
	{
		$objResponse->addAssign("port.msg", "innerHTML", "");
		if(!is_numeric($port))
		{
			$error++;
			$objResponse->addAssign("port.msg", "innerHTML", "You must type a valid port <b>number</b>.");
			$objResponse->addScript("$('port.msg').setStyle('display', 'block');");
		}
		else 
		{
			$objResponse->addScript("$('port.msg').setStyle('display', 'none');");
			$objResponse->addAssign("port.msg", "innerHTML", "");
		}
	}
	// rcon
	if(!empty($rcon) && $rcon != $rcon2)
	{
		$error++;
		$objResponse->addAssign("rcon2.msg", "innerHTML", "You must type the server RCON password.");
		$objResponse->addScript("$('rcon2.msg').setStyle('display', 'block');");
	}
	else 
	{
		$objResponse->addAssign("rcon2.msg", "innerHTML", "");
	}
	
	// Please Select 
	if($mod == -2)
	{
		$error++;
		$objResponse->addAssign("mod.msg", "innerHTML", "You must select the mod your server runs.");
		$objResponse->addScript("$('mod.msg').setStyle('display', 'block');");
	}
	else 
	{
		$objResponse->addAssign("mod.msg", "innerHTML", "");
	}
	
	if($group == -2)
	{
		$error++;
		$objResponse->addAssign("group.msg", "innerHTML", "You must select an option.");
		$objResponse->addScript("$('group.msg').setStyle('display', 'block');");
	}
	else 
	{
		$objResponse->addAssign("group.msg", "innerHTML", "");
	}
	if($error)
		return $objResponse;
		
	// ##############################################################
	// ##                     Start adding to DB                   ##
	// ##############################################################
	//they wanna make a new group
	$gid = -1;
	$sid = nextSid();
	
	// Add the server
	$addserver = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_servers (`sid`, `ip`, `port`, `rcon`, `modid`)
										  VALUES (?,?,?,?,?)");
	$GLOBALS['db']->Execute($addserver,array($sid, $ip, $port, $rcon, $mod));	
	
	// Add server to each group specified
	$groups = explode(",", $group);
	$addtogrp = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_servers_groups (`server_id`, `group_id`) VALUES (?,?)");
	foreach($groups AS $g)
	{
		if($g)
			$GLOBALS['db']->Execute($addtogrp,array($sid, $g));
	}
		

	$objResponse->addScript("ShowBox('Server Added', 'Your server has been successfully created.', 'green', '?p=admin&c=servers');");
    $objResponse->addScript("TabToReload();");
	return $objResponse;
}


function UpdateGroupPermissions($gid)
{
	$objResponse = new xajaxResponse();
	if($gid == 1)
	{
		$permissions = @file_get_contents(TEMPLATES_PATH . "/groups.web.perm.php");
		$permissions = str_replace("{title}", "Web Admin Permissions", $permissions);
	}
	elseif($gid == 2)
	{
		$permissions = @file_get_contents(TEMPLATES_PATH . "/groups.server.perm.php");
		$permissions = str_replace("{title}", "Server Admin Permissions", $permissions);
	}
	elseif($gid == 3)
		$permissions = "";
	$objResponse->addAssign("perms", "innerHTML", $permissions);	
	$objResponse->addAssign("type.msg", "innerHTML", "");
	return $objResponse;
}

function UpdateAdminPermissions($type, $value)
{
	$objResponse = new xajaxResponse();
	if($type == 1)
	{
		$id = "web";
		if($value == "c")
		{
			$permissions = @file_get_contents(TEMPLATES_PATH . "/groups.web.perm.php");
			$permissions = str_replace("{title}", "Web Admin Permissions", $permissions);
		}
		elseif($value == "n")
		{
			$permissions = @file_get_contents(TEMPLATES_PATH . "/group.name.php") . @file_get_contents(TEMPLATES_PATH . "/groups.web.perm.php");
			$permissions = str_replace("{name}", "webname", $permissions);
			$permissions = str_replace("{title}", "New Group Permissions", $permissions);
		}
		else 
			$permissions = "";
	}
	if($type == 2)
	{
		$id = "server";
		if($value == "c")
		{
			$permissions = file_get_contents(TEMPLATES_PATH . "/groups.server.perm.php");
			$permissions = str_replace("{title}", "Server Admin Permissions", $permissions);
		}
		elseif($value == "n")
		{
			$permissions = @file_get_contents(TEMPLATES_PATH . "/group.name.php") . @file_get_contents(TEMPLATES_PATH . "/groups.server.perm.php");
			$permissions = str_replace("{name}", "servername", $permissions);
			$permissions = str_replace("{title}", "New Group Permissions", $permissions);
		}
		else 
			$permissions = "";
	}
	
	$objResponse->addAssign($id."perm", "innerHTML", $permissions);	
	$objResponse->addAssign($id.".msg", "innerHTML", "");
	return $objResponse;

}

function AddServerGroupName()
{
	$objResponse = new xajaxResponse();
	$inject = '<td valign="top"><div class="rowdesc">' . HelpIcon("Server Group Name", "Please type the name of the new group you wish to create.") . 'Group Name </div></td>';
	$inject .= '<td><div align="left">
        <input type="text" style="border: 1px solid #000000; width: 105px; font-size: 14px; background-color: rgb(215, 215, 215);width: 200px;" id="sgroup" name="sgroup" />
      </div>
        <div id="group_name.msg" style="color:#CC0000;width:195px;display:none;"></div></td>
  ';
	$objResponse->addAssign("nsgroup", "innerHTML", $inject);	
	$objResponse->addAssign("group.msg", "innerHTML", "");
	return $objResponse;

}

function AddAdmin($mask, $srv_mask, $a_name, $a_steam, $a_email, $a_password, $a_password2,	$a_sg, $a_wg, $a_spass, $a_webname, $a_servername, $server, $singlesrv)
{
	$a_name = RemoveCode($a_name);
	$a_steam = RemoveCode($a_steam);
	$a_email = RemoveCode($a_email);
	$a_servername = RemoveCode($a_servername);
	$a_webname = RemoveCode($a_webname);
	
	$objResponse = new xajaxResponse();
	$error=0;
	
	//No name
	if(empty($a_name))
	{
		$error++;
		$objResponse->addAssign("name.msg", "innerHTML", "You must type a name for the admin.");
		$objResponse->addScript("$('name.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("name.msg", "innerHTML", "");
		$objResponse->addScript("$('name.msg').setStyle('display', 'none');");
		if(is_taken("admins", "user", $a_name))
		{
			$error++;
			$objResponse->addAssign("name.msg", "innerHTML", "An admin with this name already exists");
			$objResponse->addScript("$('name.msg').setStyle('display', 'block');");
		}
		else 
		{
			$objResponse->addAssign("name.msg", "innerHTML", "");
			$objResponse->addScript("$('name.msg').setStyle('display', 'none');");
		}
	}
	// If they didnt type a steamid, and didnt check the use password box
	if((empty($a_steam) || strlen($a_steam) < 10) && $a_spass == 0)
	{
		$error++;
		$objResponse->addAssign("steam.msg", "innerHTML", "You must type a STEAM ID for the admin.");
		$objResponse->addScript("$('steam.msg').setStyle('display', 'block');");
	}
	else
	{
		$objResponse->addAssign("steam.msg", "innerHTML", "");
		$objResponse->addScript("$('steam.msg').setStyle('display', 'none');");
		if(!validate_steam($a_steam))
		{
			$error++;
			$objResponse->addAssign("steam.msg", "innerHTML", "Please enter a valid STEAM id.");
			$objResponse->addScript("$('steam.msg').setStyle('display', 'block');");
		}	
		else
		{
			$objResponse->addAssign("steam.msg", "innerHTML", "");
			$objResponse->addScript("$('steam.msg').setStyle('display', 'none');");
			if(is_taken("admins", "authid", $a_steam))
			{
				$error++;
				$objResponse->addAssign("name.msg", "innerHTML", "An admin with this STEAM already exists");
				$objResponse->addScript("$('steam.msg').setStyle('display', 'block');");
			}
			else 
			{
				$objResponse->addAssign("name.msg", "innerHTML", "");
				$objResponse->addScript("$('steam.msg').setStyle('display', 'none');");
			}
		}
	}
	// If they only want server admin, we dont need an email
	if(empty($a_email) && (check_group($mask) == GROUP_WEB_A || check_group($mask) == GROUP_NONE_A))
	{
		$error++;
		$objResponse->addAssign("email.msg", "innerHTML", "You must type an e-mail address.");
		$objResponse->addScript("$('email.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("email.msg", "innerHTML", "");
		$objResponse->addScript("$('email.msg').setStyle('display', 'none');");
		if(is_taken("admins", "email", $a_email))
		{
			$error++;
			$objResponse->addAssign("email.msg", "innerHTML", "This email address is already being used.");
			$objResponse->addScript("$('email.msg').setStyle('display', 'block');");
		}
		else 
		{
			$objResponse->addAssign("email.msg", "innerHTML", "");
			$objResponse->addScript("$('email.msg').setStyle('display', 'none');");
		/*	if(!validate_email($a_email))
			{
				$error++;
				$objResponse->addAssign("email.msg", "innerHTML", "Please enter a valid email address.");
				$objResponse->addScript("$('email.msg').setStyle('display', 'block');");
			}
			else 
			{
				$objResponse->addAssign("email.msg", "innerHTML", "");
				$objResponse->addScript("$('email.msg').setStyle('display', 'none');");
				
			}*/
		}
	}
	// no pass
	if(empty($a_password) && $srv_mask != SM_RESERVED_SLOT)
	{
		$error++;
		$objResponse->addAssign("password.msg", "innerHTML", "You must type a password.");
		$objResponse->addScript("$('password.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("password.msg", "innerHTML", "");
		$objResponse->addScript("$('password.msg').setStyle('display', 'none');");
	}
	
	if(empty($a_password2))
	{
		$error++;
		$objResponse->addAssign("password2.msg", "innerHTML", "You must type a password");
		$objResponse->addScript("$('password2.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("password2.msg", "innerHTML", "");
		$objResponse->addScript("$('password2.msg').setStyle('display', 'none');");
	}
	
	// no match
	if($a_password != $a_password2 && !empty($a_password2))
	{
		$error++;
		$objResponse->addAssign("password2.msg", "innerHTML", "Your passwords dont match");
		$objResponse->addScript("$('password2.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("password2.msg", "innerHTML", "");
		$objResponse->addScript("$('password2.msg').setStyle('display', 'none');");
	}
	if(strlen($a_password) < MIN_PASS_LENGTH)
	{
		$error++;
		$objResponse->addAssign("password.msg", "innerHTML", "Your password must be at-least " . MIN_PASS_LENGTH . " characters long.");
		$objResponse->addScript("$('password.msg').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("password.msg", "innerHTML", "");
		$objResponse->addScript("$('password.msg').setStyle('display', 'none');");
	}
	
	// chose a new group, but didnt type a name
	if($a_sg == 'n' && empty($a_servername))
	{
		$error++;
		$objResponse->addAssign("servername_err", "innerHTML", "You need to type a name for the new group.");
		$objResponse->addScript("$('servername_err').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("servername_err", "innerHTML", "");
		$objResponse->addScript("$('servername_err').setStyle('display', 'none');");
		if(strstr($a_servername, ','))
		{
			$error++;
			$objResponse->addAssign("servername_err", "innerHTML", "Group name cannot contain a ','");
			$objResponse->addScript("$('servername_err').setStyle('display', 'block');");
		}
		else{
			$objResponse->addAssign("servername_err", "innerHTML", "");
			$objResponse->addScript("$('servername_err').setStyle('display', 'none');");
		}
	}
	if($a_wg == 'n' && empty($a_webname))
	{
		$error++;
		$objResponse->addAssign("webname_err", "innerHTML", "You need to type a name for the new group.");
		$objResponse->addScript("$('webname_err').setStyle('display', 'block');");
	}
	else{
		$objResponse->addAssign("webname_err", "innerHTML", "");
		$objResponse->addScript("$('webname_err').setStyle('display', 'none');");
		if(strstr($a_webname, ','))
		{
			$error++;
			$objResponse->addAssign("webname_err", "innerHTML", "Group name cannot contain a ','");
			$objResponse->addScript("$('webname_err').setStyle('display', 'block');");
		}
		else{
			$objResponse->addAssign("webname_err", "innerHTML", "");
			$objResponse->addScript("$('webname_err').setStyle('display', 'none');");
		}
	}
	// Ohnoes! something went wrong, stop and show errs
	if($error)
		return $objResponse;
		
// ##############################################################
// ##                     Start adding to DB                   ##
// ##############################################################
	// They chose a web group, but custom server group
	$gid = 0;
	$done = false;
	$newGroup = "";
	$groupID = 0;
	$inGroup = false;
	$wgid = NextAid();
	
	
	
	if(($a_wg > -1 && $a_wg != 'n' && $a_wg != 'c') && ($a_sg == 'n' || $a_sg == 'c'))
	{	
		// Add custom group for that admin
		if($a_sg == 'c')
		{
			// ##############################################################
			// ##                     Add non group Admin		           ##
			// ##############################################################
			$done = true;			
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
					VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", " ", $srv_mask, $a_name, $wgid));	
		}
		// Add a new group
		elseif($a_sg == 'n')
		{
			$groupID = NextGid();
			$newGroup = $a_servername;
			// ##############################################################
			// ##              Add New Group + Server Admin                ##
			// ##############################################################
			$inGroup = true;
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvgroups(immunity,flags,name,groups_immune)
					VALUES (?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("", $srv_mask, $a_servername, "none"));
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
					VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", $a_servername, "", $a_name, $wgid));	
			
		}
		// ##############################################################
		// ##                     Add Web Admin		                   ##
		// ##############################################################
		$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?, ?,?,?,?,?,?)");
		$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), $a_wg, $a_email, 0));
	}
	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
	// They chose a server group, and custom web group
	if(($a_sg > -1 && $a_sg != 'n' && $a_sg != 'c') && ($a_wg == 'n' || $a_wg == 'c'))
	{	
		$sg = $GLOBALS['db']->GetRow("SELECT `flags`, `name` FROM `" . DB_PREFIX . "_groups` WHERE gid='" . $a_sg . "'");
		$mask |= intval($sg[0]);
		$newGroup = $sg[1];
		$wmask = $mask;
	
		// Add custom group for that admin
		if($a_wg == 'c')
		{
			$done = true;			
			// ##############################################################
			// ##               Custom Web Admin		                   ##
			// ##############################################################
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?, ?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), -1, $a_email, $wmask));
		}
		// Add a new group
		elseif($a_wg == 'n')
		{
			// ##############################################################
			// ##               New	 Web Group			                   ##
			// ##############################################################
			$id = NextGid();
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_groups(gid, type,name,flags)
											VALUES (?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($id, 0, $a_webname, $wmask));
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?, ?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), $id, $a_email, 0));
		}
		// ##############################################################
		// ##               New	Server Admin 		                   ##
		// ##############################################################
		$inGroup = true;
		$groupname = $GLOBALS['db']->GetRow("SELECT `name` FROM ".DB_PREFIX."_srvgroups WHERE id = '" . $a_sg . "'");
		$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
											VALUES (?,?,?,?,?,?,?)");
		$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", $groupname['name'], "", $a_name, $wgid));
	}
	
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	

	// They chose 2 custom/new group types
	if(($a_wg == 'n' || $a_wg == 'c') && ($a_sg == 'n' || $a_sg == 'c'))
	{
		$wmask = $mask;
		$smask = $mask;
		//we need to toggle off any server flags to extract the web flags
		
		$smask &= ~(ALL_WEB);
		
		if($a_wg == 'n')
		{
			// ##############################################################
			// ##               New	Web Group	 		                   ##
			// ##############################################################
			$id = NextGid();
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_groups(gid,type,name,flags)
											VALUES (?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($id, 0, $a_webname, $wmask));
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), $id, $a_email, 0));
		}
		if($a_sg == 'n')
		{
			// ##############################################################
			// ##               New	Server Group	 	                   ##
			// ##############################################################
			$inGroup = true;
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvgroups(immunity,flags,name,groups_immune)
					VALUES (?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("", $srv_mask, $a_servername, "none"));
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
					VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", $a_servername, " ", $a_name, $wgid));
		}	
		if($a_wg == 'c')
		{
			// ##############################################################
			// ##               Custom web Group	 	                   ##
			// ##############################################################
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), -1, $a_email, $wmask));	
		}
		if($a_sg == 'c')
		{
			// ##############################################################
			// ##               Custom server admin	 	                   ##
			// ##############################################################
			$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
					VALUES (?,?,?,?,?,?,?)");
			$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", " ", $srv_mask, $a_name, $wgid));	
		}
	}
		
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	// They chose 2 ready-made groups
	if(($a_sg > -1 && $a_sg != 'n' && $a_sg != 'c') && ($a_wg > -1 && $a_wg != 'n' && $a_wg != 'c'))
	{	
		$inGroup = true;
		$groupname = $GLOBALS['db']->GetRow("SELECT `name` FROM ".DB_PREFIX."_srvgroups WHERE id = '" . $a_sg . "'");
		$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_srvadmins(authtype,identity,password,groups,flags,name,external_id)
											VALUES (?,?,?,?,?,?,?)");
		$GLOBALS['db']->Execute($sm_group,array("steam", $a_steam, "", $groupname['name'], " ", $a_name, $wgid));
		$sm_group = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins(aid, user,authid,password,gid, email, extraflags)
											VALUES (?,?,?,?,?,?,?)");
		$GLOBALS['db']->Execute($sm_group,array($wgid, $a_name, $a_steam, encrypt_password($a_password), $a_wg, $a_email, 0));
	}

	
	// Link with servers
	$aid = $GLOBALS['db']->GetRow("SELECT `id` FROM ".DB_PREFIX."_srvadmins WHERE identity = '" . $a_steam . "'");
	if($inGroup == true)
	{
		if($a_sg == 'n')
			$group_id = $a_servername;
		else 
			$group_id = $a_sg;
	}
	else 
	{
		$group_id = $aid[0];
	}
	

	// Add the admin <-> server_group link
	$srv_groups = explode(",", $server);
	$addtosrvgrp = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins_servers_groups(admin_id,group_id,srv_group_id,server_id) VALUES (?,?,?,?)");
	foreach($srv_groups AS $g)
	{
		if($g)
			$GLOBALS['db']->Execute($addtosrvgrp,array($aid['0'], $group_id, substr($g, 1), 0));
	}
	$addtosrv = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_admins_servers_groups(admin_id,group_id,srv_group_id,server_id) VALUES (?,?,?,?)");
	// Add the admin <-group-> server link
	$srv_arr = explode(",", $singlesrv);
	foreach($srv_arr AS $s)
	{
		if($s)
			$GLOBALS['db']->Execute($addtosrv,array($aid['0'], $group_id, 0, substr($s, 1)));
	}
	
    $objResponse->addScript("ShowBox('User Added', 'The admin has been added successfully', 'green', '?p=admin&c=admins');");
    $objResponse->addScript("TabToReload();");
	return $objResponse;
}

function ServerHostPlayers($sid)
{
	require INCLUDES_PATH.'\CServerInfo.php';
	$sinfo = new CServerInfo();
	$res = $GLOBALS['db']->GetRow("SELECT sid, ip, port FROM ".DB_PREFIX."_servers WHERE sid = '$sid'");
	$info = array();
	$info = $sinfo->getInfo($res[1],$res[2]);

	$objResponse = new xajaxResponse();
	if(!empty($info['hostname']))
	{
		$objResponse->addAssign("host_$sid", "innerHTML", trunc($info['hostname'], 48, false));
		$objResponse->addAssign("players_$sid", "innerHTML", $info['numplayers'] . "/" . $info['maxplayers']);
	}else{
		$objResponse->addAssign("host_$sid", "innerHTML", "<b>Error connecting</b> (<i>" . $res[1] . ":" . $res[2]. "</i>)");
		$objResponse->addAssign("players_$sid", "innerHTML", "N/A");
		$objResponse->addScript("$('sid_$sid').setStyle('color', '#adadad');");
	}
	return $objResponse;
}

function AddBan($nickname, $steam, $ip, $length, $dfile, $dname, $reason, $fromsub)
{
	$nickname = RemoveCode($nickname);
	$ip = RemoveCode($ip);
	$dname = RemoveCode($dname);
	$reason = RemoveCode($reason);
	$objResponse = new xajaxResponse();
	if(!$length)
		$len = 0;
	else 
		$len = $length*60;
		
	$chk = $GLOBALS['db']->GetRow("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans WHERE authid = '" . $steam . "'");
	
	if(intval($chk[0]) > 0)
	{
		$objResponse->addScript("ShowBox('Error', 'SteamID: " . $steam . " is already banned.', 'red', '');");
		return $objResponse;
	}
	
	$pre = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_bans(created,ip,authid,name,ends,length,reason,aid,adminIp ) VALUES 
									(UNIX_TIMESTAMP(),?,?,?,(UNIX_TIMESTAMP() + ?),?,?,?,?)");
	$GLOBALS['db']->Execute($pre,array($ip,
									   $steam,
									   $nickname,
									   $length*60,
									   $len, 
									   $reason, 
									   $_COOKIE['aid'], 
									   $_SERVER['REMOTE_ADDR']));
	$subid = $GLOBALS['db']->Insert_ID();
	
	if($dname && $dfile)
	{
		$GLOBALS['db']->Execute("INSERT INTO ".DB_PREFIX."_demos(demid,demtype,filename,origname) 
						     VALUES($subid,'B','$dfile', '". $dname ."')");
	}
	if($fromsub)
		$GLOBALS['db']->Execute("DELETE FROM `" . DB_PREFIX . "_submissions` WHERE subid = '" . $fromsub . "'");

	
	
	$objResponse->addScript("ShowBox('Ban Added', 'The ban has been successfully added', 'green', '?p=admin&c=bans');");
    $objResponse->addScript("TabToReload();");
	return $objResponse;
}

function SetupBan($subid)
{
	$objResponse = new xajaxResponse();
	$ban = $GLOBALS['db']->GetRow("SELECT * FROM ".DB_PREFIX."_submissions WHERE subid = \"". $subid . "\"");
	$demo = $GLOBALS['db']->GetRow("SELECT * FROM ".DB_PREFIX."_demos WHERE demid = \"". $subid . "\" AND demtype = \"S\"");
	// clear any old stuff
	$objResponse->addScript("$('nickname').value = ''");
	$objResponse->addScript("$('fromsub').value = ''");
	$objResponse->addScript("$('steam').value = ''");
	$objResponse->addScript("$('reason').value = ''");
	$objResponse->addAssign("demo.msg", "innerHTML",  "");
	$objResponse->addAssign("reason", "innerHTML",  "");
	// add new stuff
	$objResponse->addScript("$('nickname').value = '" . $ban['name'] . "'");
	$objResponse->addScript("$('steam').value = '" . $ban['SteamId']. "'");
	$objResponse->addScript("$('reason').value = '" . $ban['reason']. "'");
	$objResponse->addScript("$('fromsub').value = '$subid'");
	if($demo)
	{
		$objResponse->addAssign("demo.msg", "innerHTML",  $demo['origname']);
		$objResponse->addScript("demo('" . $demo['filename'] . "', '" . $demo['origname'] . "');");
	}
	$objResponse->addAssign("reason", "innerHTML",  $ban['reason']);
	$objResponse->addScript("SwapPane(0);");
	return $objResponse;
}

function SetupEditServer($sid)
{
	$objResponse = new xajaxResponse();
	$server = $GLOBALS['db']->GetRow("SELECT * FROM ".DB_PREFIX."_servers WHERE sid = \"". $sid . "\"");
	
	// clear any old stuff
	$objResponse->addScript("$('address').value = ''");
	$objResponse->addScript("$('port').value = ''");
	$objResponse->addScript("$('rcon').value = ''");
	$objResponse->addScript("$('rcon2').value = ''");
	$objResponse->addScript("$('mod').value = '0'");
	$objResponse->addScript("$('serverg').value = '0'");
	
	
	// add new stuff
	$objResponse->addScript("$('address').value = '" . $server['ip']. "'");
	$objResponse->addScript("$('port').value =  '" . $server['port']. "'");
	$objResponse->addScript("$('rcon').value =  '" . $server['rcon']. "'");
	$objResponse->addScript("$('rcon2').value =  '" . $server['rcon']. "'");
	$objResponse->addScript("$('mod').value =  " . $server['modid']);
	$objResponse->addScript("$('serverg').value =  " . $server['gid']);

	$objResponse->addScript("$('insert_type').value =  " . $server['sid']);
	$objResponse->addScript("SwapPane(1);");
	return $objResponse;
}

function CheckPassword($aid, $pass)
{
	$objResponse = new xajaxResponse();
	if(!check_login($aid, $pass))
	{
		$objResponse->addScript("$('current.msg').setStyle('display', 'block');");
		$objResponse->addScript("$('current.msg').setHTML('Incorrect password.');");
		$objResponse->addScript("set_error(1);");
		
	}
	else 
	{
		$objResponse->addScript("$('current.msg').setStyle('display', 'none');");
		$objResponse->addScript("set_error(0);");
	}
	return $objResponse;
}
function ChangePassword($aid, $pass)
{
	$objResponse = new xajaxResponse();
	
	$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_admins` SET `password` = '" . encrypt_password($pass) . "' WHERE `aid` = '" . $aid . "'");
	$objResponse->addAlert("Password changed successfully");
	$objResponse->addRedirect("index.php?p=login", 0);
	return $objResponse;
}

function AddMod($name, $folder, $icon)
{
	$objResponse = new xajaxResponse();
	$name = RemoveCode($name);
	$pre = $GLOBALS['db']->Prepare("INSERT INTO ".DB_PREFIX."_mods(name,icon,modfolder) VALUES (?,?,?)");
	$GLOBALS['db']->Execute($pre,array($name,
									   $icon,
									   $folder));

									   
	$objResponse->addScript("ShowBox('MOD Added', 'The game MOD has been successfully added', 'green', '?p=admin&c=mods');");
    $objResponse->addScript("TabToReload();");
    
	return $objResponse;
} 

function EditAdminPerms($aid, $web_flags, $srv_flags)
{
	if(empty($aid))
		return;
	// Update web stuff
	$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_admins` SET `extraflags` = $web_flags WHERE `aid` = '" . $aid . "'");
	// Update server stuff
	$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_srvadmins` SET `flags` = '$srv_flags' WHERE `external_id` = '" . $aid . "'");
	$objResponse = new xajaxResponse();
	
	$objResponse->addScript("ShowBox('User Added', 'The admin has been added successfully', 'green', '?p=admin&c=admins');");
    $objResponse->addScript("TabToReload();");
	
    
    $objResponse->addScript("ShowBox('Permissions updated', 'The user`s permissions have been updated successfully', 'green', '?p=admin&c=admins');");
    $objResponse->addScript("TabToReload();");
    
	return $objResponse;
}

function EditGroup($gid, $web_flags, $srv_flags, $type, $name)
{
	$name = RemoveCode($name);
	if($type == "web" || $type == "server" )
	// Update web stuff
	$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_groups` SET `flags` = $web_flags, `name` = '$name' WHERE `gid` = '" . $gid . "'");
	
	if($type == "srv")
	{
		$gname = $GLOBALS['db']->GetRow("SELECT name FROM ".DB_PREFIX."_srvgroups WHERE id = \"". $gid . "\"");
		// Update server stuff
		$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_srvgroups` SET `flags` = '$srv_flags', `name` = '$name' WHERE `id` = '" . $gid . "'");
		
		$oldname = $GLOBALS['db']->GetAll("SELECT * FROM ".DB_PREFIX."_srvadmins WHERE groups = \"". $gname['name'] . "\"");
		foreach($oldname as $o)
		{
			$GLOBALS['db']->Execute("UPDATE `".DB_PREFIX."_srvadmins` SET `groups` = '" . $name . "' WHERE `id` = '" . $o['id'] . "'");
		}
	}
	
	$objResponse = new xajaxResponse();
	
	$objResponse->addScript("ShowBox('Group updated', 'The group has been updated successfully', 'green', '?p=admin&c=groups');TabToReload();");
	return $objResponse;
}

function PerformBanSearch($type, $value, $pages, $aid)
{
	$BansPerPage = SB_BANS_PER_PAGE;
	$objResponse = new xajaxResponse();	
	
	if ($pages > 0)
		$page = intval($pages);
	
	$BansStart = ($page-1) * $BansPerPage;
	$BansEnd = $BansStart+$BansPerPage;
	switch($type)
	{
		case "name":
			$res = $GLOBALS['db']->Execute("SELECT * FROM ".DB_PREFIX."_bans WHERE name='" . $value . "' AND (`length` = '0' OR `ends` > UNIX_TIMESTAMP()) LIMIT $BansStart, $BansPerPage");
			$res_cnt =  $GLOBALS['db']->Execute("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans WHERE name='" . $value . "'");
		break;
		case "steam":
			$res = $GLOBALS['db']->Execute("SELECT * FROM ".DB_PREFIX."_bans WHERE authid='" . $value . "' AND (`length` = '0' OR `ends` > UNIX_TIMESTAMP()) LIMIT $BansStart, $BansPerPage");
			$res_cnt =  $GLOBALS['db']->Execute("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans WHERE authid='" . $value . "'");
		break;
		case "reason":
			$res = $GLOBALS['db']->Execute("SELECT * FROM ".DB_PREFIX."_bans WHERE reason='" . $value . "' AND (`length` = '0' OR `ends` > UNIX_TIMESTAMP()) LIMIT $BansStart, $BansPerPage");
			$res_cnt =  $GLOBALS['db']->Execute("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans WHERE reason='" . $value . "'");
		break;
		case "date":
			$date = explode(",", $value);
			$time = mktime(0,0,0,$date[1],$date[0],$date[2]);
			$time2 = mktime(23,59,59,$date[1],$date[0],$date[2]);
			$res = $GLOBALS['db']->Execute("SELECT * FROM ".DB_PREFIX."_bans WHERE created >'" . $time . "' AND created < '" . $time2 . "' AND (`length` = '0' OR `ends` > UNIX_TIMESTAMP()) LIMIT $BansStart, $BansPerPage");
			$res_cnt =  $GLOBALS['db']->Execute("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans WHERE created >'" . $time . "' AND created < '" . $time2 . "'");
			
		break;
		case "name":
			$res = $GLOBALS['db']->Execute("SELECT * FROM ".DB_PREFIX."_bans WHERE name='" . $value . "' AND (`length` = '0' OR `ends` > UNIX_TIMESTAMP()) LIMIT $BansStart, $BansPerPage");
			$res_cnt =  $GLOBALS['db']->Execute("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans WHERE name='" . $value . "'");
		break;
		case "admin":
			$res = $GLOBALS['db']->Execute("SELECT * FROM ".DB_PREFIX."_bans WHERE aid=" . $value . " AND (`length` = '0' OR `ends` > UNIX_TIMESTAMP()) LIMIT $BansStart, $BansPerPage");
			$res_cnt =  $GLOBALS['db']->Execute("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans WHERE aid='" . $value . "'");
		break;
		case "where_banned":
			$res = $GLOBALS['db']->Execute("SELECT * FROM ".DB_PREFIX."_bans WHERE sid='" . $value . "' AND (`length` = '0' OR `ends` > UNIX_TIMESTAMP()) LIMIT $BansStart, $BansPerPage");
			$res_cnt =  $GLOBALS['db']->Execute("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans WHERE sid='" . $value . "'");
		break;
		default:
			$res = $GLOBALS['db']->Execute("SELECT * FROM ".DB_PREFIX."_bans WHERE (`length` = '0' OR `ends` > UNIX_TIMESTAMP()) LIMIT $BansStart, $BansPerPage");
			$res_cnt =  $GLOBALS['db']->Execute("SELECT count(bid) AS count FROM ".DB_PREFIX."_bans");
		break;
			
	}
	
	if(!$res->fields)
	{
		$objResponse->addAssign("banlist_result", "innerHTML",  "<h2>No bans found.</h2>");
		return $objResponse;
	}
	$BanCount = $res_cnt->fields[0];
	$prev = "javascript:xajax_PerformBanSearch('$type', '$value', " . ($page-1) . ", $aid);";
	$nxt = "javascript:xajax_PerformBanSearch('$type', '$value', " . ($page+1) . ", $aid);";
	if ($page > 1)
		$prev = CreateLinkR('<img border="0" alt="prev" src="images/left.gif" style="vertical-align:middle;" /> prev',"javascript:void(0);", "", "_self", false, $prev);
	else
		$prev = "";
		
	if ($BansEnd < $BanCount)
		$next = CreateLinkR('next <img border="0" alt="next" src="images/right.gif" style="vertical-align:middle;" />',"javascript:void(0);", "", "_self", false, $nxt);
	else
		$next = "";
	
	$bans = array();
	$pre = $GLOBALS['db']->Prepare("SELECT count(*) FROM ".DB_PREFIX."_banhistory WHERE AuthId=?");
	$ServerCache = CreateHostnameCache();
	while (!$res->EOF)
	{
		$icon = $GLOBALS['db']->GetRow("SELECT icon FROM ".DB_PREFIX."_mods WHERE mid = (SELECT modid FROM ".DB_PREFIX."_servers WHERE sid = " . $res->fields[10] . ")");
		$admin = $GLOBALS['db']->GetRow("SELECT user FROM ".DB_PREFIX."_admins WHERE aid = " . $res->fields[aid]);
		$data = array();
		
		if(!empty($res->fields[ip]))
		{
			if(!empty($res->fields[country]))
				$data['country'] = '<img src="images/country/' .$res->fields[country] . '.gif" alt="' . $res->fields[country] . '" border="0" align="absmiddle" />';
			else 
			{
				$country = FetchIp($res->fields[ip]);
				$edit = $GLOBALS['db']->Execute("UPDATE ".DB_PREFIX."_bans SET
									`country` = '" . $country . "'
									WHERE `bid` = '". $res->fields[bid] . "'");
				$data['country'] = '<img src="images/country/' . $country . '.gif" alt="' . $res->fields[country] . '" border="0" align="absmiddle" />';
			}
		}
		
		$data['ban_date'] = date('d-m-y',$res->fields[4]);
		$data['player'] = $res->fields[3];
		$data['steamid'] = $res->fields[2];
		$data['admin'] = $admin[0];
		$data['reason'] = $res->fields[7];
		$data['ban_length'] = $res->fields[6] == 0 ? 'Permanent' : SecondsToString(intval($res->fields[6]));
		$data['layer_id'] = 'layer_'.$res->fields[0];
		$data['details_link'] = CreateLinkR('click','getdemo.php?type=B&id='.$res->fields[0]);
		$data['edit_link'] = CreateLinkR('<img src="images/edit.gif" border="0" alt="" style="vertical-align:middle" /> Edit Details',"index.php?p=admin&c=bans&o=edit&id=".$res->fields[0]."&key=".$_SESSION['banlist_postkey']);
		$data['unban_link'] = CreateLinkR('<img src="images/locked.gif" border="0" alt="" style="vertical-align:middle" /> Unban',"index.php?p=banlist&a=unban&id=".$res->fields[0]."&key=".$_SESSION['banlist_postkey']);
		$data['delete_link'] = CreateLinkR('<img src="images/delete.gif" border="0" alt="" style="vertical-align:middle" /> Delete Ban',"index.php?p=banlist&a=delete&id=".$res->fields[0]."&key=".$_SESSION['banlist_postkey']);
		$data['prevoff_link'] = "0";
		$data['server_id'] = $res->fields['sid'];
		
		if(!empty($icon[0]))
				$data['mod_icon'] = '<img src="images/games/' .$icon[0] . '" alt="MOD" border="0" align="middle" />';
		else 
			$data['mod_icon'] = '<img src="images/games/web.png" alt="MOD" border="0" alt="web ban" align="middle" />';
		
		$res2 = $GLOBALS['db']->Execute($pre,array($data['steamid']));
		if ($res2 && $res2->fields[0] > 0)
			$data['prevoff_link'] = CreateLinkR($res2->fields[2],"index.php?p=prevoff&id=".$res->fields[0]);
		
		if ($res2 && $res->fields[12] != 0)
			$data['prevoff_link'] = $res->fields[11];
		else
			$data['prevoff_link'] = 'unknown';
		
		if (strlen($res->fields[ip]) < 7)
			$data['ip'] = 'none';
		else
			$data['ip'] = $data['country'] . '&nbsp;' . $res->fields[ip];
		
		if ($res->fields[5] == 0)
			$data['expires'] = 'never';
		else
			$data['expires'] = date('m-d-y',$res->fields[5]);
			
		$res2 = $GLOBALS['db']->Execute("SELECT demid FROM ".DB_PREFIX."_demos WHERE demtype='B' and demid=".$res->fields[0]);
		if (!$res2 || $res2->RecordCount() == 0)
		{
			$data['demo_quick'] = 'N/A';
			$data['demo_link'] = CreateLinkR('<img src="images/demo.gif" border="0" alt="" style="vertical-align:middle" /> No Demos',"#");
		}
		elseif ($res2 && $res2->RecordCount() == 1)
		{
			$data['demo_quick'] = CreateLinkR('Demo',"getdemo.php?type=B&id=".$res->fields[0]);
			$data['demo_link'] = CreateLinkR('<img src="images/demo.gif" border="0" alt="" style="vertical-align:middle" /> Review Demo',"getdemo.php?type=B&id=".$res->fields[0]);
		}
		else
		{
			//Multiple demos..
			$data['demo_quick'] = 'Demos';
			$data['demo_link'] = '<img src="images/demo.gif" border="0" alt="" style="vertical-align:middle" /> Review Demos';
		}
		$data['server'] = $ServerCache[$res->fields[10]];
		array_push($bans,$data);
		$res->MoveNext();
		
	}
	global $cur;
	$header = '<h3 align="left">Banlist Overview</h3>';
	$pages = round($BanCount/$BansPerPage);
	if($pages == 0)
		$pages = 1;
	$header .= '<div id="banlist-nav">Page ' . $page . ' of ' . $pages;
	if (strlen($prev) > 0)
		$header .= '| <b>'.$prev.'</b>';
	if (strlen($next) > 0)
		$header .= '| <b>'.$next.'</b>';
		
	$header .= "</div>" . include(TEMPLATES_PATH . "/banlist.header.php");
	$GLOBALS['aid'] = $aid;
	$GLOBALS['admin'] = true;
	foreach ($bans as $cur)
	{
		$banlen = explode(',',$cur['ban_length']);
		$cur['banlength'] = $banlen[0];
		$ban .=  include(TEMPLATES_PATH . "/banlist.bandetail.php");		
	}
	$foot = include(TEMPLATES_PATH . "/banlist.footer.php");
	
	$objResponse->addAssign("banlist_result", "innerHTML",  $header . $ban . $foot);
	$objResponse->addScript("InitAccordion('tr.opener', 'div.opener', 'mainwrapper');");
	
	return $objResponse;
}


function SendRcon($sid, $command, $output)
{
	$objResponse = new xajaxResponse();
	if($command == "clr")
	{
		$objResponse->addAssign("rcon_con", "innerHTML",  "");
		$objResponse->addScript("scroll.toBottom(); $('cmd').value=''; $('cmd').disabled='';");
		return $objResponse;
	}
	$rcon = $GLOBALS['db']->GetRow("SELECT ip, port, rcon FROM ".DB_PREFIX."_servers WHERE sid = \"". $sid . "\"");
	include(INCLUDES_PATH . "/CServerRcon.php");
	$r = new CServerRcon($rcon['ip'], $rcon['port'], $rcon['rcon']);
	if(!$r->Auth())
	{
		$objResponse->addAssign("rcon_con", "innerHTML",  "> Error: Wrong RCON password!\nYou MUST change the RCON password for this server in the 'edit server' \npage. If you continue to use this console with the wrong password, \nthe server will block the connection!");
		$objResponse->addScript("scroll.toBottom(); $('cmd').value='Change RCON password.'; ");
		return $objResponse;
	}
	$ret = $r->rconCommand($command);
	
	
	if(empty($ret))
	{
		if($output)
		{
			$objResponse->addAppend("rcon_con", "innerHTML",  "-> $command\n");
			$objResponse->addAppend("rcon_con", "innerHTML",  "Command Executed.\n");
		}
	}
	else 
	{
		if($output)
		{
			$objResponse->addAppend("rcon_con", "innerHTML",  "-> $command\n");
			$objResponse->addAppend("rcon_con", "innerHTML",  "$ret\n");
		}
	}
	$objResponse->addScript("scroll.toBottom(); $('cmd').value=''; $('cmd').disabled=''; $('rcon_btn').disabled=''");
	return $objResponse;
}

function SendMail($subject, $message, $amail, $email)
{
	$objResponse = new xajaxResponse();
	$headers = 'From: ' . $amail . '\n' .
    'X-Mailer: PHP/' . phpversion();
	$m = mail($email, $subject, $message, $headers);
	
	$objResponse->addScript("ShowBox('Email Sent', 'The email has been sent to the user.', 'green', '?p=admin&c=bans');");
	return $objResponse;
}
?>